import * as i0 from '@angular/core';
import { Component, Input, Injectable, Directive, EventEmitter, Output, Optional, NgModule, Pipe, Inject, TemplateRef, ContentChild, ContentChildren, ViewChild } from '@angular/core';
import * as i1$1 from '@angular/common';
import { CommonModule } from '@angular/common';
import { BehaviorSubject, Subject, takeUntil } from 'rxjs';
import { deepMerge, deepEquals, trapFocus, SortDirection, resolveProperty, multipleSortFunction, pageNums, flattenGroups, groupBy, randomString, clone } from 'ez-functions';
import * as i1 from '@angular/forms';
import { NG_VALIDATORS } from '@angular/forms';
import * as i1$2 from '@angular/router';
import { RouterModule } from '@angular/router';

class EzControlBaseComponent {
    constructor() {
        this.properties = {
            dirty: false,
            fieldset: false,
            invalid: false,
            labelledby: '',
            maxlength: '',
            message: '',
            name: '',
            placeholder: '',
            pristine: true,
            readonly: false,
            required: false,
            submitted: false,
            valid: true,
        };
        this.metaData = {
            localReadonly: false,
            directiveReadonly: false,
        };
        this.messages = {};
        this.value = undefined;
        this.propagateChange = (_) => { };
    }
    set fieldset(value) {
        this.properties.fieldset = value !== false && value !== 'false';
    }
    set labelledby(value) {
        this.properties.labelledby = `${value}`;
    }
    set maxlength(value) {
        this.properties.name = `${value}`;
    }
    set name(value) {
        this.properties.name = value;
    }
    set placeholder(value) {
        this.properties.placeholder = value;
    }
    set readonly(value) {
        this.metaData.localReadonly = value !== false && value !== 'false';
        this.properties.readonly = this.metaData.localReadonly || this.metaData.directiveReadonly;
    }
    set required(value) {
        this.properties.required = value !== false && value !== 'false';
    }
    writeValue(value) {
        this.value = value;
    }
    registerOnChange(fn) {
        this.propagateChange = fn;
    }
    registerOnTouched() { }
    onChange(value) {
        this.value = value;
        this.propagateChange(this.value);
    }
}
EzControlBaseComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.2.0", ngImport: i0, type: EzControlBaseComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
EzControlBaseComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "14.2.0", type: EzControlBaseComponent, selector: "ez-control-base", inputs: { fieldset: "fieldset", labelledby: "labelledby", maxlength: "maxlength", name: "name", placeholder: "placeholder", readonly: "readonly", required: "required", messages: "messages" }, ngImport: i0, template: '', isInline: true });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.2.0", ngImport: i0, type: EzControlBaseComponent, decorators: [{
            type: Component,
            args: [{ selector: 'ez-control-base', template: '' }]
        }], propDecorators: { fieldset: [{
                type: Input
            }], labelledby: [{
                type: Input
            }], maxlength: [{
                type: Input
            }], name: [{
                type: Input
            }], placeholder: [{
                type: Input
            }], readonly: [{
                type: Input
            }], required: [{
                type: Input
            }], messages: [{
                type: Input
            }] } });

class EzFormConfigService {
    constructor() {
        this.defaultMessages = {
            invalid: 'Invalid response',
            required: 'Response required',
        };
        this.fieldsetTemplate = null;
        this.labelTemplate = null;
        this.readonlyTemplate = null;
        this.requiredIndicator = true;
        this.pristineMessages = false;
        this.formClasses = '';
        this.formSubmittedClasses = '';
        this.controlClasses = '';
        this.legendClasses = '';
        this.labelContainerClasses = '';
        this.labelClasses = '';
        this.controlsContainerClasses = '';
        this.checkboxLabelClasses = '';
        this.radioLabelClasses = '';
        this.sublabelClasses = '';
        this.readonlyLabelClasses = '';
        this.readonlyClasses = '';
        this.requiredClasses = '';
        this.validationClasses = '';
        this.inputClasses = '';
        this.checkboxClasses = '';
        this.checkboxContainerClasses = '';
        this.radioClasses = '';
        this.radioContainerClasses = '';
        this.selectClasses = '';
        this.fieldsetLabelClasses = '';
    }
}
EzFormConfigService.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.2.0", ngImport: i0, type: EzFormConfigService, deps: [], target: i0.ɵɵFactoryTarget.Injectable });
EzFormConfigService.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "14.2.0", ngImport: i0, type: EzFormConfigService, providedIn: 'root' });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.2.0", ngImport: i0, type: EzFormConfigService, decorators: [{
            type: Injectable,
            args: [{
                    providedIn: 'root',
                }]
        }] });

class EzFormReadonlyDirective {
    constructor() {
        this.readonly$ = new BehaviorSubject(false);
    }
    set ezFormReadonly(value) {
        this.readonly$.next(value !== false && value !== 'false');
    }
}
EzFormReadonlyDirective.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.2.0", ngImport: i0, type: EzFormReadonlyDirective, deps: [], target: i0.ɵɵFactoryTarget.Directive });
EzFormReadonlyDirective.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "14.2.0", type: EzFormReadonlyDirective, selector: "[ezFormReadonly]", inputs: { ezFormReadonly: "ezFormReadonly" }, ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.2.0", ngImport: i0, type: EzFormReadonlyDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[ezFormReadonly]',
                }]
        }], propDecorators: { ezFormReadonly: [{
                type: Input
            }] } });

class EzFormConfigDirective {
    constructor(configService) {
        this.configService = configService;
        this.config$ = new BehaviorSubject(this.configService);
    }
    set ezFormConfig(value) {
        this.config$.next(deepMerge(this.configService, value));
    }
}
EzFormConfigDirective.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.2.0", ngImport: i0, type: EzFormConfigDirective, deps: [{ token: EzFormConfigService }], target: i0.ɵɵFactoryTarget.Directive });
EzFormConfigDirective.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "14.2.0", type: EzFormConfigDirective, selector: "[ezFormConfig]", inputs: { ezFormConfig: "ezFormConfig" }, ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.2.0", ngImport: i0, type: EzFormConfigDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[ezFormConfig]',
                }]
        }], ctorParameters: function () { return [{ type: EzFormConfigService }]; }, propDecorators: { ezFormConfig: [{
                type: Input
            }] } });

class EzFormDirective {
    constructor(form, el, configService) {
        this.form = form;
        this.el = el;
        this.ezSubmit = new EventEmitter();
        this.ezSubmitInvalid = new EventEmitter();
        this.ezReset = new EventEmitter();
        const elm = el.nativeElement;
        elm.classList.add('ez-form');
        if (configService.formClasses) {
            if (typeof configService.formClasses === 'string') {
                configService.formClasses.split(' ').forEach((formClass) => {
                    elm.classList.add(formClass);
                });
            }
            else if (Array.isArray(configService.formClasses)) {
                configService.formClasses.forEach((formClass) => {
                    elm.classList.add(formClass);
                });
            }
        }
        if (configService.formSubmittedClasses) {
            if (typeof configService.formSubmittedClasses === 'string') {
                this.formSubmittedClasses = configService.formSubmittedClasses.split(' ');
            }
            else if (Array.isArray(configService.formSubmittedClasses)) {
                this.formSubmittedClasses = configService.formSubmittedClasses;
            }
        }
        this.subscription = form.ngSubmit.subscribe(() => {
            this.onSubmit(el.nativeElement);
            if (form.valid) {
                this.ezSubmit.emit(form.value);
            }
            else {
                this.ezSubmitInvalid.emit(form.value);
            }
        });
        elm.addEventListener('reset', () => {
            this.reset();
        });
    }
    ngOnDestroy() {
        var _a;
        (_a = this.subscription) === null || _a === void 0 ? void 0 : _a.unsubscribe();
    }
    onSubmit(elm) {
        elm.classList.add('ez-submitted');
        if (this.formSubmittedClasses) {
            this.formSubmittedClasses.forEach((formClass) => {
                elm.classList.add(formClass);
            });
        }
        const invalid = elm.querySelector('.ng-invalid .ng-invalid input, .ng-invalid .ng-invalid select, .ng-invalid .ng-invalid textarea');
        if (invalid) {
            invalid.focus();
        }
        else {
            const validation = elm.querySelector('.ng-invalid .ng-invalid .ez-validation');
            if (validation) {
                validation.scrollIntoView();
                validation.focus();
            }
        }
    }
    reset(value) {
        const elm = this.el.nativeElement;
        elm.classList.remove('ez-submitted');
        if (this.formSubmittedClasses) {
            this.formSubmittedClasses.forEach((formClass) => {
                elm.classList.remove(formClass);
            });
        }
        this.form.resetForm(value);
        this.ezReset.emit(value);
    }
}
EzFormDirective.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.2.0", ngImport: i0, type: EzFormDirective, deps: [{ token: i1.NgForm }, { token: i0.ElementRef }, { token: EzFormConfigService }], target: i0.ɵɵFactoryTarget.Directive });
EzFormDirective.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "14.2.0", type: EzFormDirective, selector: "form", outputs: { ezSubmit: "ezSubmit", ezSubmitInvalid: "ezSubmitInvalid", ezReset: "ezReset" }, exportAs: ["ezForm"], ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.2.0", ngImport: i0, type: EzFormDirective, decorators: [{
            type: Directive,
            args: [{
                    // eslint-disable-next-line @angular-eslint/directive-selector
                    selector: 'form',
                    exportAs: 'ezForm',
                }]
        }], ctorParameters: function () { return [{ type: i1.NgForm }, { type: i0.ElementRef }, { type: EzFormConfigService }]; }, propDecorators: { ezSubmit: [{
                type: Output
            }], ezSubmitInvalid: [{
                type: Output
            }], ezReset: [{
                type: Output
            }] } });

class EzControlComponent {
    constructor(ezControlBaseComponent, ezFormConfigService, ezFormReadonlyDirective, ezFormConfigDirective, ngControl, ezFormDirective) {
        this.ezFormConfigService = ezFormConfigService;
        this.config = this.ezFormConfigService;
        this.finalise$ = new Subject();
        this.properties = ezControlBaseComponent.properties;
        ezFormDirective === null || ezFormDirective === void 0 ? void 0 : ezFormDirective.ezSubmit.pipe(takeUntil(this.finalise$)).subscribe(() => {
            this.properties.submitted = true;
        });
        ezFormDirective === null || ezFormDirective === void 0 ? void 0 : ezFormDirective.ezSubmitInvalid.pipe(takeUntil(this.finalise$)).subscribe(() => {
            this.properties.submitted = true;
        });
        ezFormDirective === null || ezFormDirective === void 0 ? void 0 : ezFormDirective.ezReset.pipe(takeUntil(this.finalise$)).subscribe(() => {
            this.properties.submitted = false;
        });
        if (ngControl) {
            ngControl.valueAccessor = ezControlBaseComponent;
            if (ngControl.valueChanges) {
                ngControl.valueChanges.pipe(takeUntil(this.finalise$)).subscribe(() => {
                    var _a, _b, _c, _d;
                    this.properties.dirty = (_a = ngControl.dirty) !== null && _a !== void 0 ? _a : false;
                    this.properties.invalid = (_b = ngControl.invalid) !== null && _b !== void 0 ? _b : false;
                    this.properties.valid = (_c = ngControl.valid) !== null && _c !== void 0 ? _c : false;
                    this.properties.pristine = (_d = ngControl.pristine) !== null && _d !== void 0 ? _d : false;
                    if (ngControl.invalid) {
                        const errorType = ngControl.errors ? Object.keys(ngControl.errors)[0] : '';
                        const errorValue = (ngControl === null || ngControl === void 0 ? void 0 : ngControl.errors) ? ngControl.errors[errorType] : '';
                        this.properties.message =
                            ezControlBaseComponent.messages[errorType] ||
                                this.config.defaultMessages[errorType] ||
                                (typeof errorValue === 'string' ? errorValue : this.config.defaultMessages['invalid']);
                    }
                    else {
                        this.properties.message = '';
                    }
                });
            }
        }
        ezFormReadonlyDirective === null || ezFormReadonlyDirective === void 0 ? void 0 : ezFormReadonlyDirective.readonly$.pipe(takeUntil(this.finalise$)).subscribe((readonly) => {
            ezControlBaseComponent.metaData.directiveReadonly = readonly;
            ezControlBaseComponent.properties.readonly = readonly || ezControlBaseComponent.metaData.localReadonly;
        });
        ezControlBaseComponent.config = ezFormConfigService;
        ezFormConfigDirective === null || ezFormConfigDirective === void 0 ? void 0 : ezFormConfigDirective.config$.pipe(takeUntil(this.finalise$)).subscribe((config) => {
            this.config = config;
            ezControlBaseComponent.config = config;
        });
    }
    ngOnDestroy() {
        this.finalise$.next();
        this.finalise$.complete();
    }
}
EzControlComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.2.0", ngImport: i0, type: EzControlComponent, deps: [{ token: EzControlBaseComponent }, { token: EzFormConfigService }, { token: EzFormReadonlyDirective, optional: true }, { token: EzFormConfigDirective, optional: true }, { token: i1.NgControl, optional: true }, { token: EzFormDirective, optional: true }], target: i0.ɵɵFactoryTarget.Component });
EzControlComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "14.2.0", type: EzControlComponent, selector: "ez-control", ngImport: i0, template: "<ng-container *ngTemplateOutlet=\"properties.readonly ? readonlyTemplate : properties.fieldset ? fieldsetTemplate : labelTemplate\"></ng-container>\r\n\r\n<ng-template #fieldsetTemplate>\r\n  <fieldset class=\"ez-control\" [ngClass]=\"config.controlClasses\" *ngIf=\"!config.fieldsetTemplate; else fieldsetConfigTemplate\"\r\n    [attr.aria-describedby]=\"properties.name + '_validation_message'\">\r\n    <legend class=\"ez-legend\" [ngClass]=\"config.legendClasses\">\r\n      <span class=\"ez-label\" [ngClass]=\"config.fieldsetLabelClasses\">\r\n        <ng-container *ngTemplateOutlet=\"contentTemplate\"></ng-container>\r\n        <span class=\"ez-required\" *ngIf=\"config.requiredIndicator && properties.required\"> *</span>\r\n      </span>\r\n    </legend>\r\n    <div class=\"ez-controls\" [ngClass]=\"config.controlsContainerClasses\">\r\n      <ng-container *ngTemplateOutlet=\"controlsTemplate\"></ng-container>\r\n    </div>\r\n    <ng-container *ngTemplateOutlet=\"validationTemplate\"></ng-container>\r\n  </fieldset>\r\n  <ng-template #fieldsetConfigTemplate>\r\n    <ng-container *ngTemplateOutlet=\"\r\n      config.fieldsetTemplate;\r\n      context: { $implicit: properties, config: config, contentTemplate: contentTemplate, controlsTemplate: controlsTemplate, validationTemplate: validationTemplate }\r\n    \">\r\n    </ng-container>\r\n  </ng-template>\r\n</ng-template>\r\n\r\n<ng-template #labelTemplate>\r\n  <div class=\"ez-control\" [ngClass]=\"config.controlClasses\" *ngIf=\"!config.labelTemplate; else labelConfigTemplate\">\r\n    <div class=\"ez-label-container\" [ngClass]=\"config.labelContainerClasses\">\r\n      <label class=\"ez-label\" [ngClass]=\"config.labelClasses\" [id]=\"properties.name + '_control_input_label'\" [for]=\"properties.name + '_control_input'\">\r\n        <ng-container *ngTemplateOutlet=\"contentTemplate\"></ng-container>\r\n        <span class=\"ez-required\" *ngIf=\"config.requiredIndicator && properties.required\"> *</span>\r\n      </label>\r\n    </div>\r\n    <div class=\"ez-controls\" [ngClass]=\"config.controlsContainerClasses\">\r\n      <ng-container *ngTemplateOutlet=\"controlsTemplate\"></ng-container>\r\n    </div>\r\n    <ng-container *ngTemplateOutlet=\"validationTemplate\"></ng-container>\r\n  </div>\r\n  <ng-template #labelConfigTemplate>\r\n    <ng-container *ngTemplateOutlet=\"\r\n        config.labelTemplate;\r\n        context: { $implicit: properties, config: config, contentTemplate: contentTemplate, controlsTemplate: controlsTemplate, validationTemplate: validationTemplate }\r\n      \">\r\n    </ng-container>\r\n  </ng-template>\r\n</ng-template>\r\n\r\n<ng-template #readonlyTemplate>\r\n  <div class=\"ez-control\" [ngClass]=\"config.controlClasses\" *ngIf=\"!config.readonlyTemplate; else readonlyConfigTemplate\">\r\n    <div [ngClass]=\"config.labelContainerClasses\">\r\n      <span class=\"ez-label\" [ngClass]=\"config.readonlyLabelClasses\">\r\n        <ng-container *ngTemplateOutlet=\"contentTemplate\"></ng-container>\r\n      </span>\r\n    </div>\r\n    <div class=\"ez-controls\" [ngClass]=\"config.controlsContainerClasses\">\r\n      <span class=\"ez-readonly\" [ngClass]=\"config.readonlyClasses\">\r\n        <ng-container *ngTemplateOutlet=\"controlsTemplate\"></ng-container>\r\n      </span>\r\n    </div>\r\n  </div>\r\n  <ng-template #readonlyConfigTemplate>\r\n    <ng-container *ngTemplateOutlet=\"\r\n        config.readonlyTemplate;\r\n        context: { $implicit: properties, config: config, contentTemplate: contentTemplate, controlsTemplate: controlsTemplate, validationTemplate: validationTemplate }\r\n      \">\r\n    </ng-container>\r\n  </ng-template>\r\n</ng-template>\r\n\r\n<ng-template #validationTemplate>\r\n  <div tabindex=\"-1\" [id]=\"properties.name + '_validation_message'\" class=\"ez-validation\" [ngClass]=\"config.validationClasses\">\r\n    <ng-container *ngIf=\"properties.invalid && (properties.dirty || properties.submitted || config.pristineMessages)\">{{ properties.message }}</ng-container>\r\n  </div>\r\n</ng-template>\r\n\r\n<ng-template #contentTemplate>\r\n  <ng-content></ng-content>\r\n</ng-template>\r\n\r\n<ng-template #controlsTemplate>\r\n  <ng-content select=\"[controls-container]\"></ng-content>\r\n</ng-template>", styles: [""], dependencies: [{ kind: "directive", type: i1$1.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i1$1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: i1$1.NgTemplateOutlet, selector: "[ngTemplateOutlet]", inputs: ["ngTemplateOutletContext", "ngTemplateOutlet", "ngTemplateOutletInjector"] }] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.2.0", ngImport: i0, type: EzControlComponent, decorators: [{
            type: Component,
            args: [{ selector: 'ez-control', template: "<ng-container *ngTemplateOutlet=\"properties.readonly ? readonlyTemplate : properties.fieldset ? fieldsetTemplate : labelTemplate\"></ng-container>\r\n\r\n<ng-template #fieldsetTemplate>\r\n  <fieldset class=\"ez-control\" [ngClass]=\"config.controlClasses\" *ngIf=\"!config.fieldsetTemplate; else fieldsetConfigTemplate\"\r\n    [attr.aria-describedby]=\"properties.name + '_validation_message'\">\r\n    <legend class=\"ez-legend\" [ngClass]=\"config.legendClasses\">\r\n      <span class=\"ez-label\" [ngClass]=\"config.fieldsetLabelClasses\">\r\n        <ng-container *ngTemplateOutlet=\"contentTemplate\"></ng-container>\r\n        <span class=\"ez-required\" *ngIf=\"config.requiredIndicator && properties.required\"> *</span>\r\n      </span>\r\n    </legend>\r\n    <div class=\"ez-controls\" [ngClass]=\"config.controlsContainerClasses\">\r\n      <ng-container *ngTemplateOutlet=\"controlsTemplate\"></ng-container>\r\n    </div>\r\n    <ng-container *ngTemplateOutlet=\"validationTemplate\"></ng-container>\r\n  </fieldset>\r\n  <ng-template #fieldsetConfigTemplate>\r\n    <ng-container *ngTemplateOutlet=\"\r\n      config.fieldsetTemplate;\r\n      context: { $implicit: properties, config: config, contentTemplate: contentTemplate, controlsTemplate: controlsTemplate, validationTemplate: validationTemplate }\r\n    \">\r\n    </ng-container>\r\n  </ng-template>\r\n</ng-template>\r\n\r\n<ng-template #labelTemplate>\r\n  <div class=\"ez-control\" [ngClass]=\"config.controlClasses\" *ngIf=\"!config.labelTemplate; else labelConfigTemplate\">\r\n    <div class=\"ez-label-container\" [ngClass]=\"config.labelContainerClasses\">\r\n      <label class=\"ez-label\" [ngClass]=\"config.labelClasses\" [id]=\"properties.name + '_control_input_label'\" [for]=\"properties.name + '_control_input'\">\r\n        <ng-container *ngTemplateOutlet=\"contentTemplate\"></ng-container>\r\n        <span class=\"ez-required\" *ngIf=\"config.requiredIndicator && properties.required\"> *</span>\r\n      </label>\r\n    </div>\r\n    <div class=\"ez-controls\" [ngClass]=\"config.controlsContainerClasses\">\r\n      <ng-container *ngTemplateOutlet=\"controlsTemplate\"></ng-container>\r\n    </div>\r\n    <ng-container *ngTemplateOutlet=\"validationTemplate\"></ng-container>\r\n  </div>\r\n  <ng-template #labelConfigTemplate>\r\n    <ng-container *ngTemplateOutlet=\"\r\n        config.labelTemplate;\r\n        context: { $implicit: properties, config: config, contentTemplate: contentTemplate, controlsTemplate: controlsTemplate, validationTemplate: validationTemplate }\r\n      \">\r\n    </ng-container>\r\n  </ng-template>\r\n</ng-template>\r\n\r\n<ng-template #readonlyTemplate>\r\n  <div class=\"ez-control\" [ngClass]=\"config.controlClasses\" *ngIf=\"!config.readonlyTemplate; else readonlyConfigTemplate\">\r\n    <div [ngClass]=\"config.labelContainerClasses\">\r\n      <span class=\"ez-label\" [ngClass]=\"config.readonlyLabelClasses\">\r\n        <ng-container *ngTemplateOutlet=\"contentTemplate\"></ng-container>\r\n      </span>\r\n    </div>\r\n    <div class=\"ez-controls\" [ngClass]=\"config.controlsContainerClasses\">\r\n      <span class=\"ez-readonly\" [ngClass]=\"config.readonlyClasses\">\r\n        <ng-container *ngTemplateOutlet=\"controlsTemplate\"></ng-container>\r\n      </span>\r\n    </div>\r\n  </div>\r\n  <ng-template #readonlyConfigTemplate>\r\n    <ng-container *ngTemplateOutlet=\"\r\n        config.readonlyTemplate;\r\n        context: { $implicit: properties, config: config, contentTemplate: contentTemplate, controlsTemplate: controlsTemplate, validationTemplate: validationTemplate }\r\n      \">\r\n    </ng-container>\r\n  </ng-template>\r\n</ng-template>\r\n\r\n<ng-template #validationTemplate>\r\n  <div tabindex=\"-1\" [id]=\"properties.name + '_validation_message'\" class=\"ez-validation\" [ngClass]=\"config.validationClasses\">\r\n    <ng-container *ngIf=\"properties.invalid && (properties.dirty || properties.submitted || config.pristineMessages)\">{{ properties.message }}</ng-container>\r\n  </div>\r\n</ng-template>\r\n\r\n<ng-template #contentTemplate>\r\n  <ng-content></ng-content>\r\n</ng-template>\r\n\r\n<ng-template #controlsTemplate>\r\n  <ng-content select=\"[controls-container]\"></ng-content>\r\n</ng-template>" }]
        }], ctorParameters: function () {
        return [{ type: EzControlBaseComponent }, { type: EzFormConfigService }, { type: EzFormReadonlyDirective, decorators: [{
                        type: Optional
                    }] }, { type: EzFormConfigDirective, decorators: [{
                        type: Optional
                    }] }, { type: i1.NgControl, decorators: [{
                        type: Optional
                    }] }, { type: EzFormDirective, decorators: [{
                        type: Optional
                    }] }];
    } });

class ValidDirective {
    constructor(el) {
        this.el = el;
    }
    set valid(value) {
        this.el.nativeElement.setCustomValidity(value ? '' : 'invalid');
    }
}
ValidDirective.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.2.0", ngImport: i0, type: ValidDirective, deps: [{ token: i0.ElementRef }], target: i0.ɵɵFactoryTarget.Directive });
ValidDirective.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "14.2.0", type: ValidDirective, selector: "[valid]", inputs: { valid: "valid" }, ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.2.0", ngImport: i0, type: ValidDirective, decorators: [{
            type: Directive,
            args: [{
                    // eslint-disable-next-line @angular-eslint/directive-selector
                    selector: '[valid]',
                }]
        }], ctorParameters: function () { return [{ type: i0.ElementRef }]; }, propDecorators: { valid: [{
                type: Input
            }] } });

class EzFormsModule {
}
EzFormsModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.2.0", ngImport: i0, type: EzFormsModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
EzFormsModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "14.2.0", ngImport: i0, type: EzFormsModule, declarations: [EzControlComponent, EzFormDirective, EzFormConfigDirective, ValidDirective, EzFormReadonlyDirective], imports: [CommonModule], exports: [EzControlComponent, EzFormDirective, EzFormConfigDirective, ValidDirective, EzFormReadonlyDirective] });
EzFormsModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "14.2.0", ngImport: i0, type: EzFormsModule, imports: [CommonModule] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.2.0", ngImport: i0, type: EzFormsModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [EzControlComponent, EzFormDirective, EzFormConfigDirective, ValidDirective, EzFormReadonlyDirective],
                    imports: [CommonModule],
                    exports: [EzControlComponent, EzFormDirective, EzFormConfigDirective, ValidDirective, EzFormReadonlyDirective],
                }]
        }] });

class EzCheckboxComponent extends EzControlBaseComponent {
    constructor() {
        super(...arguments);
        this.disabled = false;
    }
}
EzCheckboxComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.2.0", ngImport: i0, type: EzCheckboxComponent, deps: null, target: i0.ɵɵFactoryTarget.Component });
EzCheckboxComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "14.2.0", type: EzCheckboxComponent, selector: "ez-checkbox", inputs: { sublabel: "sublabel", disabled: "disabled" }, providers: [{ provide: EzControlBaseComponent, useExisting: EzCheckboxComponent }], usesInheritance: true, ngImport: i0, template: "<ez-control>\r\n  <ng-content></ng-content>\r\n  <ng-container controls-container>\r\n    <div [ngClass]=\"config.checkboxContainerClasses\">\r\n      <input [id]=\"properties.name + '_control_input'\" [attr.aria-describedby]=\"properties.name + '_validation_message'\" [attr.aria-labelledby]=\"properties.labelledby\"\r\n        [value]=\"value\" type=\"checkbox\" [ngClass]=\"config.checkboxClasses\" [disabled]=\"properties.readonly || disabled\" [checked]=\"value\"\r\n        (change)=\"onChange($any($event.target).checked)\" [valid]=\"properties.valid\">\r\n      <span class=\"ez-sublabel\" [ngClass]=\"config.sublabelClasses\" *ngIf=\"sublabel\">{{sublabel}}</span>\r\n    </div>\r\n  </ng-container>\r\n</ez-control>", styles: [""], dependencies: [{ kind: "directive", type: i1$1.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i1$1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "component", type: EzControlComponent, selector: "ez-control" }, { kind: "directive", type: ValidDirective, selector: "[valid]", inputs: ["valid"] }] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.2.0", ngImport: i0, type: EzCheckboxComponent, decorators: [{
            type: Component,
            args: [{ selector: 'ez-checkbox', providers: [{ provide: EzControlBaseComponent, useExisting: EzCheckboxComponent }], template: "<ez-control>\r\n  <ng-content></ng-content>\r\n  <ng-container controls-container>\r\n    <div [ngClass]=\"config.checkboxContainerClasses\">\r\n      <input [id]=\"properties.name + '_control_input'\" [attr.aria-describedby]=\"properties.name + '_validation_message'\" [attr.aria-labelledby]=\"properties.labelledby\"\r\n        [value]=\"value\" type=\"checkbox\" [ngClass]=\"config.checkboxClasses\" [disabled]=\"properties.readonly || disabled\" [checked]=\"value\"\r\n        (change)=\"onChange($any($event.target).checked)\" [valid]=\"properties.valid\">\r\n      <span class=\"ez-sublabel\" [ngClass]=\"config.sublabelClasses\" *ngIf=\"sublabel\">{{sublabel}}</span>\r\n    </div>\r\n  </ng-container>\r\n</ez-control>" }]
        }], propDecorators: { sublabel: [{
                type: Input
            }], disabled: [{
                type: Input
            }] } });

class EzCheckboxModule {
}
EzCheckboxModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.2.0", ngImport: i0, type: EzCheckboxModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
EzCheckboxModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "14.2.0", ngImport: i0, type: EzCheckboxModule, declarations: [EzCheckboxComponent], imports: [CommonModule, EzFormsModule], exports: [EzCheckboxComponent] });
EzCheckboxModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "14.2.0", ngImport: i0, type: EzCheckboxModule, imports: [CommonModule, EzFormsModule] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.2.0", ngImport: i0, type: EzCheckboxModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [EzCheckboxComponent],
                    exports: [EzCheckboxComponent],
                    imports: [CommonModule, EzFormsModule],
                }]
        }] });

class EzCheckboxesComponent extends EzControlBaseComponent {
    writeValue(value) {
        if (value) {
            this.value = value;
        }
        else if (this.value && typeof this.value === 'object') {
            this.options.forEach((option) => {
                var _a;
                this.value && (this.value[(_a = option.property) !== null && _a !== void 0 ? _a : ''] = false);
            });
        }
    }
    onValueChange(input, option) {
        var _a;
        if (this.value) {
            this.value[(_a = option.property) !== null && _a !== void 0 ? _a : ''] = input.target.checked;
            this.propagateChange(this.value);
        }
    }
}
EzCheckboxesComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.2.0", ngImport: i0, type: EzCheckboxesComponent, deps: null, target: i0.ɵɵFactoryTarget.Component });
EzCheckboxesComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "14.2.0", type: EzCheckboxesComponent, selector: "ez-checkboxes", inputs: { options: "options" }, providers: [{ provide: EzControlBaseComponent, useExisting: EzCheckboxesComponent }], usesInheritance: true, ngImport: i0, template: "<ez-control fieldset>\r\n  <ng-content></ng-content>\r\n  <ng-container controls-container>\r\n    <div [ngClass]=\"config.checkboxContainerClasses\" *ngFor=\"let option of options\">\r\n      <label [ngClass]=\"config.checkboxLabelClasses\">\r\n        <input type=\"checkbox\" [checked]=\"value && value[option.property ?? '']\" [disabled]=\"properties.readonly || option.disabled\" (change)=\"onValueChange($event, option)\"\r\n          [ngClass]=\"config.checkboxClasses\" [valid]=\"properties.valid\">\r\n        {{option.label}}\r\n      </label>\r\n    </div>\r\n  </ng-container>\r\n</ez-control>", styles: [""], dependencies: [{ kind: "directive", type: i1$1.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i1$1.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { kind: "component", type: EzControlComponent, selector: "ez-control" }, { kind: "directive", type: ValidDirective, selector: "[valid]", inputs: ["valid"] }] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.2.0", ngImport: i0, type: EzCheckboxesComponent, decorators: [{
            type: Component,
            args: [{ selector: 'ez-checkboxes', providers: [{ provide: EzControlBaseComponent, useExisting: EzCheckboxesComponent }], template: "<ez-control fieldset>\r\n  <ng-content></ng-content>\r\n  <ng-container controls-container>\r\n    <div [ngClass]=\"config.checkboxContainerClasses\" *ngFor=\"let option of options\">\r\n      <label [ngClass]=\"config.checkboxLabelClasses\">\r\n        <input type=\"checkbox\" [checked]=\"value && value[option.property ?? '']\" [disabled]=\"properties.readonly || option.disabled\" (change)=\"onValueChange($event, option)\"\r\n          [ngClass]=\"config.checkboxClasses\" [valid]=\"properties.valid\">\r\n        {{option.label}}\r\n      </label>\r\n    </div>\r\n  </ng-container>\r\n</ez-control>" }]
        }], propDecorators: { options: [{
                type: Input
            }] } });

class EzCheckboxesModule {
}
EzCheckboxesModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.2.0", ngImport: i0, type: EzCheckboxesModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
EzCheckboxesModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "14.2.0", ngImport: i0, type: EzCheckboxesModule, declarations: [EzCheckboxesComponent], imports: [CommonModule, EzFormsModule], exports: [EzCheckboxesComponent] });
EzCheckboxesModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "14.2.0", ngImport: i0, type: EzCheckboxesModule, imports: [CommonModule, EzFormsModule] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.2.0", ngImport: i0, type: EzCheckboxesModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [EzCheckboxesComponent],
                    exports: [EzCheckboxesComponent],
                    imports: [CommonModule, EzFormsModule],
                }]
        }] });

class EzPasswordComponent extends EzControlBaseComponent {
}
EzPasswordComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.2.0", ngImport: i0, type: EzPasswordComponent, deps: null, target: i0.ɵɵFactoryTarget.Component });
EzPasswordComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "14.2.0", type: EzPasswordComponent, selector: "ez-password", providers: [{ provide: EzControlBaseComponent, useExisting: EzPasswordComponent }], usesInheritance: true, ngImport: i0, template: "<ez-control>\r\n  <ng-content></ng-content>\r\n  <ng-container controls-container>\r\n    <ng-container *ngIf=\"properties.readonly else elseBlock\">********</ng-container>\r\n    <ng-template #elseBlock>\r\n      <input [id]=\"properties.name + '_control_input'\" [attr.aria-describedby]=\"properties.name + '_validation_message'\" [attr.aria-labelledby]=\"properties.labelledby\"\r\n        [attr.maxlength]=\"properties.maxlength\" [value]=\"value || ''\" type=\"password\" [attr.placeholder]=\"properties.placeholder\" (blur)=\"onChange($any($event.target).value)\"\r\n        (keydown.enter)=\"onChange($any($event.target).value)\" [ngClass]=\"config.inputClasses\" [valid]=\"properties.valid\">\r\n    </ng-template>\r\n  </ng-container>\r\n</ez-control>\r\n", styles: [""], dependencies: [{ kind: "directive", type: i1$1.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i1$1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "component", type: EzControlComponent, selector: "ez-control" }, { kind: "directive", type: ValidDirective, selector: "[valid]", inputs: ["valid"] }] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.2.0", ngImport: i0, type: EzPasswordComponent, decorators: [{
            type: Component,
            args: [{ selector: 'ez-password', providers: [{ provide: EzControlBaseComponent, useExisting: EzPasswordComponent }], template: "<ez-control>\r\n  <ng-content></ng-content>\r\n  <ng-container controls-container>\r\n    <ng-container *ngIf=\"properties.readonly else elseBlock\">********</ng-container>\r\n    <ng-template #elseBlock>\r\n      <input [id]=\"properties.name + '_control_input'\" [attr.aria-describedby]=\"properties.name + '_validation_message'\" [attr.aria-labelledby]=\"properties.labelledby\"\r\n        [attr.maxlength]=\"properties.maxlength\" [value]=\"value || ''\" type=\"password\" [attr.placeholder]=\"properties.placeholder\" (blur)=\"onChange($any($event.target).value)\"\r\n        (keydown.enter)=\"onChange($any($event.target).value)\" [ngClass]=\"config.inputClasses\" [valid]=\"properties.valid\">\r\n    </ng-template>\r\n  </ng-container>\r\n</ez-control>\r\n" }]
        }] });

class EzPasswordModule {
}
EzPasswordModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.2.0", ngImport: i0, type: EzPasswordModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
EzPasswordModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "14.2.0", ngImport: i0, type: EzPasswordModule, declarations: [EzPasswordComponent], imports: [CommonModule, EzFormsModule], exports: [EzPasswordComponent] });
EzPasswordModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "14.2.0", ngImport: i0, type: EzPasswordModule, imports: [CommonModule, EzFormsModule] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.2.0", ngImport: i0, type: EzPasswordModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [EzPasswordComponent],
                    exports: [EzPasswordComponent],
                    imports: [CommonModule, EzFormsModule],
                }]
        }] });

class ReferencePipe {
    transform(value, options) {
        var _a;
        return (_a = options === null || options === void 0 ? void 0 : options.find((o) => o.value === value)) === null || _a === void 0 ? void 0 : _a.label;
    }
}
ReferencePipe.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.2.0", ngImport: i0, type: ReferencePipe, deps: [], target: i0.ɵɵFactoryTarget.Pipe });
ReferencePipe.ɵpipe = i0.ɵɵngDeclarePipe({ minVersion: "14.0.0", version: "14.2.0", ngImport: i0, type: ReferencePipe, name: "reference" });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.2.0", ngImport: i0, type: ReferencePipe, decorators: [{
            type: Pipe,
            args: [{
                    name: 'reference',
                }]
        }] });

class EzRadioComponent extends EzControlBaseComponent {
    writeValue(value) {
        var _a, _b, _c;
        super.writeValue((_c = (_b = (_a = this.options) === null || _a === void 0 ? void 0 : _a.find((o) => deepEquals(o.value, value))) === null || _b === void 0 ? void 0 : _b.value) !== null && _c !== void 0 ? _c : value);
    }
}
EzRadioComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.2.0", ngImport: i0, type: EzRadioComponent, deps: null, target: i0.ɵɵFactoryTarget.Component });
EzRadioComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "14.2.0", type: EzRadioComponent, selector: "ez-radio", inputs: { options: "options" }, providers: [{ provide: EzControlBaseComponent, useExisting: EzRadioComponent }], usesInheritance: true, ngImport: i0, template: "<ez-control fieldset>\r\n  <ng-content></ng-content>\r\n  <ng-container controls-container>\r\n    <ng-container *ngIf=\"properties.readonly else elseBlock\">{{ value | reference: options }}</ng-container>\r\n    <ng-template #elseBlock>\r\n      <div [ngClass]=\"config.radioContainerClasses\" *ngFor=\"let option of options\">\r\n        <label [ngClass]=\"config.radioLabelClasses\">\r\n          <input type=\"radio\" [name]=\"properties.name + '_radio_input'\" (change)=\"onChange(option.value)\" [checked]=\"value === option.value\" [ngClass]=\"config.radioClasses\"\r\n            [valid]=\"properties.valid\" />\r\n          {{ option.label }}\r\n        </label>\r\n      </div>\r\n    </ng-template>\r\n  </ng-container>\r\n</ez-control>", styles: [""], dependencies: [{ kind: "directive", type: i1$1.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i1$1.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { kind: "directive", type: i1$1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "component", type: EzControlComponent, selector: "ez-control" }, { kind: "directive", type: ValidDirective, selector: "[valid]", inputs: ["valid"] }, { kind: "pipe", type: ReferencePipe, name: "reference" }] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.2.0", ngImport: i0, type: EzRadioComponent, decorators: [{
            type: Component,
            args: [{ selector: 'ez-radio', providers: [{ provide: EzControlBaseComponent, useExisting: EzRadioComponent }], template: "<ez-control fieldset>\r\n  <ng-content></ng-content>\r\n  <ng-container controls-container>\r\n    <ng-container *ngIf=\"properties.readonly else elseBlock\">{{ value | reference: options }}</ng-container>\r\n    <ng-template #elseBlock>\r\n      <div [ngClass]=\"config.radioContainerClasses\" *ngFor=\"let option of options\">\r\n        <label [ngClass]=\"config.radioLabelClasses\">\r\n          <input type=\"radio\" [name]=\"properties.name + '_radio_input'\" (change)=\"onChange(option.value)\" [checked]=\"value === option.value\" [ngClass]=\"config.radioClasses\"\r\n            [valid]=\"properties.valid\" />\r\n          {{ option.label }}\r\n        </label>\r\n      </div>\r\n    </ng-template>\r\n  </ng-container>\r\n</ez-control>" }]
        }], propDecorators: { options: [{
                type: Input
            }] } });

class ReferencePipeModule {
}
ReferencePipeModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.2.0", ngImport: i0, type: ReferencePipeModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
ReferencePipeModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "14.2.0", ngImport: i0, type: ReferencePipeModule, declarations: [ReferencePipe], imports: [CommonModule], exports: [ReferencePipe] });
ReferencePipeModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "14.2.0", ngImport: i0, type: ReferencePipeModule, imports: [CommonModule] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.2.0", ngImport: i0, type: ReferencePipeModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [ReferencePipe],
                    exports: [ReferencePipe],
                    imports: [CommonModule],
                }]
        }] });

class EzRadioModule {
}
EzRadioModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.2.0", ngImport: i0, type: EzRadioModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
EzRadioModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "14.2.0", ngImport: i0, type: EzRadioModule, declarations: [EzRadioComponent], imports: [CommonModule, EzFormsModule, ReferencePipeModule], exports: [EzRadioComponent] });
EzRadioModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "14.2.0", ngImport: i0, type: EzRadioModule, imports: [CommonModule, EzFormsModule, ReferencePipeModule] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.2.0", ngImport: i0, type: EzRadioModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [EzRadioComponent],
                    exports: [EzRadioComponent],
                    imports: [CommonModule, EzFormsModule, ReferencePipeModule],
                }]
        }] });

class EzSelectComponent extends EzControlBaseComponent {
    constructor() {
        super(...arguments);
        this.showDefault = true;
        this.defaultText = 'Please select..';
        this.defaultValue = undefined;
    }
    writeValue(value) {
        var _a, _b, _c;
        super.writeValue((_c = (_b = (_a = this.options) === null || _a === void 0 ? void 0 : _a.find((o) => deepEquals(o.value, value))) === null || _b === void 0 ? void 0 : _b.value) !== null && _c !== void 0 ? _c : value);
    }
    lookupIndex(index) {
        var _a;
        super.onChange(index === '-1' ? this.defaultValue : (_a = this.options[parseInt(index)]) === null || _a === void 0 ? void 0 : _a.value);
    }
}
EzSelectComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.2.0", ngImport: i0, type: EzSelectComponent, deps: null, target: i0.ɵɵFactoryTarget.Component });
EzSelectComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "14.2.0", type: EzSelectComponent, selector: "ez-select", inputs: { options: "options", showDefault: "showDefault", defaultText: "defaultText", defaultValue: "defaultValue" }, providers: [{ provide: EzControlBaseComponent, useExisting: EzSelectComponent }], usesInheritance: true, ngImport: i0, template: "<ez-control>\r\n  <ng-content></ng-content>\r\n  <ng-container controls-container>\r\n    <ng-container *ngIf=\"properties.readonly else elseBlock\">{{ value | reference: options }}</ng-container>\r\n    <ng-template #elseBlock>\r\n      <select [id]=\"properties.name + '_control_input'\" [attr.aria-describedby]=\"properties.name + '_validation_message'\" [attr.aria-labelledby]=\"properties.labelledby\"\r\n        [ngClass]=\"config.selectClasses\" [valid]=\"properties.valid\" (change)=\"lookupIndex($any($event.target).value)\">\r\n        <option *ngIf=\"showDefault\" value=\"-1\" [selected]=\"value === defaultValue\">{{defaultText}}</option>\r\n        <option *ngFor=\"let option of options; let i = index\" [value]=\"i\" [selected]=\"value === option.value\">{{option.label}}</option>\r\n      </select>\r\n    </ng-template>\r\n  </ng-container>\r\n</ez-control>", styles: [""], dependencies: [{ kind: "directive", type: i1$1.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i1$1.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { kind: "directive", type: i1$1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "component", type: EzControlComponent, selector: "ez-control" }, { kind: "directive", type: ValidDirective, selector: "[valid]", inputs: ["valid"] }, { kind: "pipe", type: ReferencePipe, name: "reference" }] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.2.0", ngImport: i0, type: EzSelectComponent, decorators: [{
            type: Component,
            args: [{ selector: 'ez-select', providers: [{ provide: EzControlBaseComponent, useExisting: EzSelectComponent }], template: "<ez-control>\r\n  <ng-content></ng-content>\r\n  <ng-container controls-container>\r\n    <ng-container *ngIf=\"properties.readonly else elseBlock\">{{ value | reference: options }}</ng-container>\r\n    <ng-template #elseBlock>\r\n      <select [id]=\"properties.name + '_control_input'\" [attr.aria-describedby]=\"properties.name + '_validation_message'\" [attr.aria-labelledby]=\"properties.labelledby\"\r\n        [ngClass]=\"config.selectClasses\" [valid]=\"properties.valid\" (change)=\"lookupIndex($any($event.target).value)\">\r\n        <option *ngIf=\"showDefault\" value=\"-1\" [selected]=\"value === defaultValue\">{{defaultText}}</option>\r\n        <option *ngFor=\"let option of options; let i = index\" [value]=\"i\" [selected]=\"value === option.value\">{{option.label}}</option>\r\n      </select>\r\n    </ng-template>\r\n  </ng-container>\r\n</ez-control>" }]
        }], propDecorators: { options: [{
                type: Input
            }], showDefault: [{
                type: Input
            }], defaultText: [{
                type: Input
            }], defaultValue: [{
                type: Input
            }] } });

class EzSelectModule {
}
EzSelectModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.2.0", ngImport: i0, type: EzSelectModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
EzSelectModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "14.2.0", ngImport: i0, type: EzSelectModule, declarations: [EzSelectComponent], imports: [CommonModule, EzFormsModule, ReferencePipeModule], exports: [EzSelectComponent] });
EzSelectModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "14.2.0", ngImport: i0, type: EzSelectModule, imports: [CommonModule, EzFormsModule, ReferencePipeModule] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.2.0", ngImport: i0, type: EzSelectModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [EzSelectComponent],
                    exports: [EzSelectComponent],
                    imports: [CommonModule, EzFormsModule, ReferencePipeModule],
                }]
        }] });

class EzTextComponent extends EzControlBaseComponent {
}
EzTextComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.2.0", ngImport: i0, type: EzTextComponent, deps: null, target: i0.ɵɵFactoryTarget.Component });
EzTextComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "14.2.0", type: EzTextComponent, selector: "ez-text", providers: [{ provide: EzControlBaseComponent, useExisting: EzTextComponent }], usesInheritance: true, ngImport: i0, template: "<ez-control>\r\n  <ng-content></ng-content>\r\n  <ng-container controls-container>\r\n    <ng-container *ngIf=\"properties.readonly; else elseBlock\">{{ value }}</ng-container>\r\n    <ng-template #elseBlock>\r\n      <input [id]=\"properties.name + '_control_input'\" [attr.aria-describedby]=\"properties.name + '_validation_message'\" [attr.aria-labelledby]=\"properties.labelledby\"\r\n        [attr.maxlength]=\"properties.maxlength\" [value]=\"value || ''\" type=\"text\" [attr.placeholder]=\"properties.placeholder\" (blur)=\"onChange($any($event.target).value)\"\r\n        (keydown.enter)=\"onChange($any($event.target).value)\" [ngClass]=\"config.inputClasses\" [valid]=\"properties.valid\" />\r\n    </ng-template>\r\n  </ng-container>\r\n</ez-control>", styles: [""], dependencies: [{ kind: "directive", type: i1$1.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i1$1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "component", type: EzControlComponent, selector: "ez-control" }, { kind: "directive", type: ValidDirective, selector: "[valid]", inputs: ["valid"] }] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.2.0", ngImport: i0, type: EzTextComponent, decorators: [{
            type: Component,
            args: [{ selector: 'ez-text', providers: [{ provide: EzControlBaseComponent, useExisting: EzTextComponent }], template: "<ez-control>\r\n  <ng-content></ng-content>\r\n  <ng-container controls-container>\r\n    <ng-container *ngIf=\"properties.readonly; else elseBlock\">{{ value }}</ng-container>\r\n    <ng-template #elseBlock>\r\n      <input [id]=\"properties.name + '_control_input'\" [attr.aria-describedby]=\"properties.name + '_validation_message'\" [attr.aria-labelledby]=\"properties.labelledby\"\r\n        [attr.maxlength]=\"properties.maxlength\" [value]=\"value || ''\" type=\"text\" [attr.placeholder]=\"properties.placeholder\" (blur)=\"onChange($any($event.target).value)\"\r\n        (keydown.enter)=\"onChange($any($event.target).value)\" [ngClass]=\"config.inputClasses\" [valid]=\"properties.valid\" />\r\n    </ng-template>\r\n  </ng-container>\r\n</ez-control>" }]
        }] });

class EzTextModule {
}
EzTextModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.2.0", ngImport: i0, type: EzTextModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
EzTextModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "14.2.0", ngImport: i0, type: EzTextModule, declarations: [EzTextComponent], imports: [CommonModule, EzFormsModule], exports: [EzTextComponent] });
EzTextModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "14.2.0", ngImport: i0, type: EzTextModule, imports: [CommonModule, EzFormsModule] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.2.0", ngImport: i0, type: EzTextModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [EzTextComponent],
                    exports: [EzTextComponent],
                    imports: [CommonModule, EzFormsModule],
                }]
        }] });

class EzYesNoComponent extends EzControlBaseComponent {
}
EzYesNoComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.2.0", ngImport: i0, type: EzYesNoComponent, deps: null, target: i0.ɵɵFactoryTarget.Component });
EzYesNoComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "14.2.0", type: EzYesNoComponent, selector: "ez-yes-no", providers: [
        { provide: EzControlBaseComponent, useExisting: EzYesNoComponent },
    ], usesInheritance: true, ngImport: i0, template: "<ez-control fieldset>\r\n  <ng-content></ng-content>\r\n  <ng-container controls-container>\r\n    <ng-container *ngIf=\"properties.readonly else elseBlock\">{{ value === 'Y' ? 'Yes' : value === 'N' ? 'No' : '' }}</ng-container>\r\n    <ng-template #elseBlock>\r\n      <div [ngClass]=\"config.radioContainerClasses\">\r\n        <label [ngClass]=\"config.radioLabelClasses\">\r\n          <input type=\"radio\" value=\"Y\" [name]=\"properties.name + '_radio_input'\" (change)=\"onChange($any($event.target).value)\" [checked]=\"value === 'Y'\"\r\n            [ngClass]=\"config.radioClasses\" [valid]=\"properties.valid\" />\r\n          Yes\r\n        </label>\r\n      </div>\r\n      <div [ngClass]=\"config.radioContainerClasses\">\r\n        <label [ngClass]=\"config.radioLabelClasses\">\r\n          <input type=\"radio\" value=\"N\" [name]=\"properties.name + '_radio_input'\" (change)=\"onChange($any($event.target).value)\" [checked]=\"value === 'N'\"\r\n            [ngClass]=\"config.radioClasses\" [valid]=\"properties.valid\" />\r\n          No\r\n        </label>\r\n      </div>\r\n    </ng-template>\r\n  </ng-container>\r\n</ez-control>", styles: [""], dependencies: [{ kind: "directive", type: i1$1.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i1$1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "component", type: EzControlComponent, selector: "ez-control" }, { kind: "directive", type: ValidDirective, selector: "[valid]", inputs: ["valid"] }] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.2.0", ngImport: i0, type: EzYesNoComponent, decorators: [{
            type: Component,
            args: [{ selector: 'ez-yes-no', providers: [
                        { provide: EzControlBaseComponent, useExisting: EzYesNoComponent },
                    ], template: "<ez-control fieldset>\r\n  <ng-content></ng-content>\r\n  <ng-container controls-container>\r\n    <ng-container *ngIf=\"properties.readonly else elseBlock\">{{ value === 'Y' ? 'Yes' : value === 'N' ? 'No' : '' }}</ng-container>\r\n    <ng-template #elseBlock>\r\n      <div [ngClass]=\"config.radioContainerClasses\">\r\n        <label [ngClass]=\"config.radioLabelClasses\">\r\n          <input type=\"radio\" value=\"Y\" [name]=\"properties.name + '_radio_input'\" (change)=\"onChange($any($event.target).value)\" [checked]=\"value === 'Y'\"\r\n            [ngClass]=\"config.radioClasses\" [valid]=\"properties.valid\" />\r\n          Yes\r\n        </label>\r\n      </div>\r\n      <div [ngClass]=\"config.radioContainerClasses\">\r\n        <label [ngClass]=\"config.radioLabelClasses\">\r\n          <input type=\"radio\" value=\"N\" [name]=\"properties.name + '_radio_input'\" (change)=\"onChange($any($event.target).value)\" [checked]=\"value === 'N'\"\r\n            [ngClass]=\"config.radioClasses\" [valid]=\"properties.valid\" />\r\n          No\r\n        </label>\r\n      </div>\r\n    </ng-template>\r\n  </ng-container>\r\n</ez-control>" }]
        }] });

class EzYesNoModule {
}
EzYesNoModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.2.0", ngImport: i0, type: EzYesNoModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
EzYesNoModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "14.2.0", ngImport: i0, type: EzYesNoModule, declarations: [EzYesNoComponent], imports: [CommonModule, EzFormsModule], exports: [EzYesNoComponent] });
EzYesNoModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "14.2.0", ngImport: i0, type: EzYesNoModule, imports: [CommonModule, EzFormsModule] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.2.0", ngImport: i0, type: EzYesNoModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [EzYesNoComponent],
                    exports: [EzYesNoComponent],
                    imports: [CommonModule, EzFormsModule],
                }]
        }] });

// eslint-disable-next-line @angular-eslint/directive-selector
class ValidatorBaseDirective {
    constructor(...inputs) {
        this.inputs = inputs;
    }
    ngOnChanges(changes) {
        if (this.inputs.some((input) => input in changes) && this.onChange) {
            this.onChange();
        }
    }
    registerOnValidatorChange(fn) {
        this.onChange = fn;
    }
}
ValidatorBaseDirective.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.2.0", ngImport: i0, type: ValidatorBaseDirective, deps: [{ token: '' }], target: i0.ɵɵFactoryTarget.Directive });
ValidatorBaseDirective.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "14.2.0", type: ValidatorBaseDirective, selector: "[validator-base]", usesOnChanges: true, ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.2.0", ngImport: i0, type: ValidatorBaseDirective, decorators: [{
            type: Directive,
            args: [{ selector: '[validator-base]' }]
        }], ctorParameters: function () {
        return [{ type: undefined, decorators: [{
                        type: Inject,
                        args: ['']
                    }] }];
    } });

class AllowedDirective extends ValidatorBaseDirective {
    constructor() {
        super('allowed');
    }
    validate(c) {
        if (c.value && this.allowed && !this.allowed.some((item) => item === c.value)) {
            return {
                allowed: 'Response is not allowed',
            };
        }
        return null;
    }
}
AllowedDirective.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.2.0", ngImport: i0, type: AllowedDirective, deps: [], target: i0.ɵɵFactoryTarget.Directive });
AllowedDirective.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "14.2.0", type: AllowedDirective, selector: "[allowed]", inputs: { allowed: "allowed" }, providers: [{ provide: NG_VALIDATORS, useExisting: AllowedDirective, multi: true }], usesInheritance: true, ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.2.0", ngImport: i0, type: AllowedDirective, decorators: [{
            type: Directive,
            args: [{
                    // eslint-disable-next-line @angular-eslint/directive-selector
                    selector: '[allowed]',
                    providers: [{ provide: NG_VALIDATORS, useExisting: AllowedDirective, multi: true }],
                }]
        }], ctorParameters: function () { return []; }, propDecorators: { allowed: [{
                type: Input
            }] } });

class AllowedValidatorModule {
}
AllowedValidatorModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.2.0", ngImport: i0, type: AllowedValidatorModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
AllowedValidatorModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "14.2.0", ngImport: i0, type: AllowedValidatorModule, declarations: [AllowedDirective], imports: [CommonModule], exports: [AllowedDirective] });
AllowedValidatorModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "14.2.0", ngImport: i0, type: AllowedValidatorModule, imports: [CommonModule] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.2.0", ngImport: i0, type: AllowedValidatorModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [AllowedDirective],
                    exports: [AllowedDirective],
                    imports: [CommonModule],
                }]
        }] });

class AlphaStartDirective {
    constructor() { }
    validate(c) {
        if (c.value && !/^[A-Za-z]/.test(c.value)) {
            return {
                alphaStart: 'Should start with a letter',
            };
        }
        return null;
    }
}
AlphaStartDirective.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.2.0", ngImport: i0, type: AlphaStartDirective, deps: [], target: i0.ɵɵFactoryTarget.Directive });
AlphaStartDirective.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "14.2.0", type: AlphaStartDirective, selector: "[alpha-start]", providers: [{ provide: NG_VALIDATORS, useExisting: AlphaStartDirective, multi: true }], ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.2.0", ngImport: i0, type: AlphaStartDirective, decorators: [{
            type: Directive,
            args: [{
                    // eslint-disable-next-line @angular-eslint/directive-selector
                    selector: '[alpha-start]',
                    providers: [{ provide: NG_VALIDATORS, useExisting: AlphaStartDirective, multi: true }],
                }]
        }], ctorParameters: function () { return []; } });

class AphaSTartValidatorModule {
}
AphaSTartValidatorModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.2.0", ngImport: i0, type: AphaSTartValidatorModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
AphaSTartValidatorModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "14.2.0", ngImport: i0, type: AphaSTartValidatorModule, declarations: [AlphaStartDirective], imports: [CommonModule], exports: [AlphaStartDirective] });
AphaSTartValidatorModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "14.2.0", ngImport: i0, type: AphaSTartValidatorModule, imports: [CommonModule] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.2.0", ngImport: i0, type: AphaSTartValidatorModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [AlphaStartDirective],
                    exports: [AlphaStartDirective],
                    imports: [CommonModule],
                }]
        }] });

class CheckboxesRequiredDirective extends ValidatorBaseDirective {
    constructor() {
        super('options');
    }
    validate(c) {
        if (!c.value ||
            (this.options && !this.options.find((option) => option.property && c.value[option.property] === true))) {
            return {
                required: true,
            };
        }
        return null;
    }
}
CheckboxesRequiredDirective.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.2.0", ngImport: i0, type: CheckboxesRequiredDirective, deps: [], target: i0.ɵɵFactoryTarget.Directive });
CheckboxesRequiredDirective.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "14.2.0", type: CheckboxesRequiredDirective, selector: "[checkboxes-required]", inputs: { options: "options" }, providers: [{ provide: NG_VALIDATORS, useExisting: CheckboxesRequiredDirective, multi: true }], usesInheritance: true, ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.2.0", ngImport: i0, type: CheckboxesRequiredDirective, decorators: [{
            type: Directive,
            args: [{
                    // eslint-disable-next-line @angular-eslint/directive-selector
                    selector: '[checkboxes-required]',
                    providers: [{ provide: NG_VALIDATORS, useExisting: CheckboxesRequiredDirective, multi: true }],
                }]
        }], ctorParameters: function () { return []; }, propDecorators: { options: [{
                type: Input
            }] } });

class CheckboxesRequiredValidatorModule {
}
CheckboxesRequiredValidatorModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.2.0", ngImport: i0, type: CheckboxesRequiredValidatorModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
CheckboxesRequiredValidatorModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "14.2.0", ngImport: i0, type: CheckboxesRequiredValidatorModule, declarations: [CheckboxesRequiredDirective], imports: [CommonModule], exports: [CheckboxesRequiredDirective] });
CheckboxesRequiredValidatorModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "14.2.0", ngImport: i0, type: CheckboxesRequiredValidatorModule, imports: [CommonModule] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.2.0", ngImport: i0, type: CheckboxesRequiredValidatorModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [CheckboxesRequiredDirective],
                    exports: [CheckboxesRequiredDirective],
                    imports: [CommonModule],
                }]
        }] });

class RangeDirective extends ValidatorBaseDirective {
    constructor() {
        super('range');
    }
    set range(range) {
        const [lower, upper] = range.split('-');
        this.lower = parseFloat(lower);
        this.upper = parseFloat(upper);
    }
    validate(c) {
        if (c.value) {
            const value = parseFloat(c.value);
            if (isNaN(value) || value < this.lower || value > this.upper) {
                return {
                    range: `Should be between ${this.lower} and ${this.upper}`,
                };
            }
        }
        return null;
    }
}
RangeDirective.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.2.0", ngImport: i0, type: RangeDirective, deps: [], target: i0.ɵɵFactoryTarget.Directive });
RangeDirective.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "14.2.0", type: RangeDirective, selector: "[range]", inputs: { range: "range" }, providers: [{ provide: NG_VALIDATORS, useExisting: RangeDirective, multi: true }], usesInheritance: true, ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.2.0", ngImport: i0, type: RangeDirective, decorators: [{
            type: Directive,
            args: [{
                    // eslint-disable-next-line @angular-eslint/directive-selector
                    selector: '[range]',
                    providers: [{ provide: NG_VALIDATORS, useExisting: RangeDirective, multi: true }],
                }]
        }], ctorParameters: function () { return []; }, propDecorators: { range: [{
                type: Input
            }] } });

class RangeValidatorModule {
}
RangeValidatorModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.2.0", ngImport: i0, type: RangeValidatorModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
RangeValidatorModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "14.2.0", ngImport: i0, type: RangeValidatorModule, declarations: [RangeDirective], imports: [CommonModule], exports: [RangeDirective] });
RangeValidatorModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "14.2.0", ngImport: i0, type: RangeValidatorModule, imports: [CommonModule] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.2.0", ngImport: i0, type: RangeValidatorModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [RangeDirective],
                    exports: [RangeDirective],
                    imports: [CommonModule],
                }]
        }] });

class SameDirective extends ValidatorBaseDirective {
    constructor() {
        super('same');
    }
    validate(c) {
        if ((c.value || this.same) && c.value !== this.same) {
            return {
                same: 'Should be the same as other value',
            };
        }
        return null;
    }
}
SameDirective.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.2.0", ngImport: i0, type: SameDirective, deps: [], target: i0.ɵɵFactoryTarget.Directive });
SameDirective.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "14.2.0", type: SameDirective, selector: "[same]", inputs: { same: "same" }, providers: [{ provide: NG_VALIDATORS, useExisting: SameDirective, multi: true }], usesInheritance: true, ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.2.0", ngImport: i0, type: SameDirective, decorators: [{
            type: Directive,
            args: [{
                    // eslint-disable-next-line @angular-eslint/directive-selector
                    selector: '[same]',
                    providers: [{ provide: NG_VALIDATORS, useExisting: SameDirective, multi: true }],
                }]
        }], ctorParameters: function () { return []; }, propDecorators: { same: [{
                type: Input
            }] } });

class SameValidatorModule {
}
SameValidatorModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.2.0", ngImport: i0, type: SameValidatorModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
SameValidatorModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "14.2.0", ngImport: i0, type: SameValidatorModule, declarations: [SameDirective], imports: [CommonModule], exports: [SameDirective] });
SameValidatorModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "14.2.0", ngImport: i0, type: SameValidatorModule, imports: [CommonModule] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.2.0", ngImport: i0, type: SameValidatorModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [SameDirective],
                    exports: [SameDirective],
                    imports: [CommonModule],
                }]
        }] });

class EzModalComponent {
    constructor(elementRef) {
        this.elementRef = elementRef;
        this.visible = false;
        this.heading = '';
        this.afterClosed = new EventEmitter();
    }
    set open$(open$) {
        if (this.openSub) {
            this.openSub.unsubscribe();
        }
        this.openSub = open$.subscribe(() => {
            if (!this.visible) {
                this.open();
            }
        });
    }
    set close$(close$) {
        if (this.closeSub) {
            this.closeSub.unsubscribe();
        }
        this.closeSub = close$.subscribe(() => {
            if (this.visible) {
                this.close();
            }
        });
    }
    close() {
        this.visible = false;
        this.afterClosed.emit();
    }
    open() {
        this.visible = true;
        setTimeout(() => {
            const element = this.elementRef.nativeElement;
            const autoFocus = element.querySelector('.auto-focus, [autoFocus]');
            if (autoFocus) {
                autoFocus.focus();
            }
            else {
                const heading = element.querySelector('app-modal .modal-head h1');
                if (heading) {
                    heading.focus();
                }
            }
            trapFocus(element.querySelector('.ez-modal'));
            element.addEventListener('keyup', (e) => {
                if (e.key === 'Escape' || e.key === 'Esc' || e.keyCode === 27) {
                    this.close();
                }
            });
        });
    }
    ngOnDestroy() {
        var _a, _b;
        (_a = this.openSub) === null || _a === void 0 ? void 0 : _a.unsubscribe();
        (_b = this.closeSub) === null || _b === void 0 ? void 0 : _b.unsubscribe();
    }
}
EzModalComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.2.0", ngImport: i0, type: EzModalComponent, deps: [{ token: i0.ElementRef }], target: i0.ɵɵFactoryTarget.Component });
EzModalComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "14.2.0", type: EzModalComponent, selector: "ez-modal", inputs: { heading: "heading", open$: "open$", close$: "close$" }, outputs: { afterClosed: "afterClosed" }, ngImport: i0, template: "<ng-container *ngIf=\"visible\">\r\n  <div class=\"ez-modal-container\">\r\n    <div class=\"ez-modal-backdrop\" (click)=\"close()\"></div>\r\n    <div class=\"ez-modal\">\r\n      <div class=\"ez-modal-head\">\r\n        <h1 tabindex=\"-1\">{{ heading }}</h1>\r\n        <a href=\"javascript:void(0)\" class=\"ez-modal-close\" (click)=\"close()\"></a>\r\n      </div>\r\n      <ng-content></ng-content>\r\n      <div class=\"ez-modal-footer\">\r\n        <ng-content select=\"[footer]\"></ng-content>\r\n      </div>\r\n    </div>\r\n  </div>\r\n</ng-container>", styles: [""], dependencies: [{ kind: "directive", type: i1$1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.2.0", ngImport: i0, type: EzModalComponent, decorators: [{
            type: Component,
            args: [{ selector: 'ez-modal', template: "<ng-container *ngIf=\"visible\">\r\n  <div class=\"ez-modal-container\">\r\n    <div class=\"ez-modal-backdrop\" (click)=\"close()\"></div>\r\n    <div class=\"ez-modal\">\r\n      <div class=\"ez-modal-head\">\r\n        <h1 tabindex=\"-1\">{{ heading }}</h1>\r\n        <a href=\"javascript:void(0)\" class=\"ez-modal-close\" (click)=\"close()\"></a>\r\n      </div>\r\n      <ng-content></ng-content>\r\n      <div class=\"ez-modal-footer\">\r\n        <ng-content select=\"[footer]\"></ng-content>\r\n      </div>\r\n    </div>\r\n  </div>\r\n</ng-container>" }]
        }], ctorParameters: function () { return [{ type: i0.ElementRef }]; }, propDecorators: { heading: [{
                type: Input
            }], afterClosed: [{
                type: Output
            }], open$: [{
                type: Input
            }], close$: [{
                type: Input
            }] } });

class EzModalModule {
}
EzModalModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.2.0", ngImport: i0, type: EzModalModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
EzModalModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "14.2.0", ngImport: i0, type: EzModalModule, declarations: [EzModalComponent], imports: [CommonModule], exports: [EzModalComponent] });
EzModalModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "14.2.0", ngImport: i0, type: EzModalModule, imports: [CommonModule] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.2.0", ngImport: i0, type: EzModalModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [EzModalComponent],
                    exports: [EzModalComponent],
                    imports: [CommonModule],
                }]
        }] });

class EzColumnComponent {
    constructor() {
        this.property = '';
        this.sortable = true;
        this.headingClass = '';
        this.cellClass = '';
        this.breakGrouping = true;
    }
    set sortableSet(val) {
        this.sortable = val !== undefined && val !== false;
    }
}
EzColumnComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.2.0", ngImport: i0, type: EzColumnComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
EzColumnComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "14.2.0", type: EzColumnComponent, selector: "ez-column", inputs: { property: "property", heading: "heading", id: "id", sortableSet: ["sortable", "sortableSet"], compare: "compare", display: "display", headingClass: "headingClass", headingId: "headingId", cellClass: "cellClass", width: "width", breakGrouping: "breakGrouping" }, queries: [{ propertyName: "template", first: true, predicate: TemplateRef, descendants: true }], ngImport: i0, template: "\r\n", styles: [""] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.2.0", ngImport: i0, type: EzColumnComponent, decorators: [{
            type: Component,
            args: [{ selector: 'ez-column', template: "\r\n" }]
        }], propDecorators: { property: [{
                type: Input
            }], heading: [{
                type: Input
            }], id: [{
                type: Input
            }], sortableSet: [{
                type: Input,
                args: ['sortable']
            }], compare: [{
                type: Input
            }], display: [{
                type: Input
            }], headingClass: [{
                type: Input
            }], headingId: [{
                type: Input
            }], cellClass: [{
                type: Input
            }], width: [{
                type: Input
            }], breakGrouping: [{
                type: Input
            }], template: [{
                type: ContentChild,
                args: [TemplateRef]
            }] } });

class EzFooterComponent {
    constructor() {
        this.cellClass = '';
        this.columns = 1;
    }
    set columnsSet(value) {
        if (typeof value === 'string') {
            this.columns = parseInt(value);
        }
        else {
            this.columns = value;
        }
    }
}
EzFooterComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.2.0", ngImport: i0, type: EzFooterComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
EzFooterComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "14.2.0", type: EzFooterComponent, selector: "ez-footer", inputs: { value: "value", cellClass: "cellClass", display: "display", columnsSet: ["columns", "columnsSet"] }, queries: [{ propertyName: "template", first: true, predicate: TemplateRef, descendants: true }], ngImport: i0, template: "\r\n", styles: [""] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.2.0", ngImport: i0, type: EzFooterComponent, decorators: [{
            type: Component,
            args: [{ selector: 'ez-footer', template: "\r\n" }]
        }], propDecorators: { value: [{
                type: Input
            }], cellClass: [{
                type: Input
            }], display: [{
                type: Input
            }], template: [{
                type: ContentChild,
                args: [TemplateRef, { static: false }]
            }], columnsSet: [{
                type: Input,
                args: ['columns']
            }] } });

class EzHeadingComponent {
    constructor() {
        this.title = '';
        this.class = '';
        this.columns = 1;
    }
    set columnsSet(value) {
        if (typeof value === 'string') {
            this.columns = parseInt(value);
        }
        else {
            this.columns = value;
        }
    }
}
EzHeadingComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.2.0", ngImport: i0, type: EzHeadingComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
EzHeadingComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "14.2.0", type: EzHeadingComponent, selector: "ez-heading", inputs: { title: "title", class: "class", columnsSet: ["columns", "columnsSet"] }, ngImport: i0, template: "\r\n", styles: [""] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.2.0", ngImport: i0, type: EzHeadingComponent, decorators: [{
            type: Component,
            args: [{ selector: 'ez-heading', template: "\r\n" }]
        }], propDecorators: { title: [{
                type: Input
            }], class: [{
                type: Input
            }], columnsSet: [{
                type: Input,
                args: ['columns']
            }] } });

class EzTableConfigService {
    constructor() {
        this.messages = {
            noData: 'No records available',
        };
        this.tableClasses = '';
        this.headingRowClasses = '';
        this.footerRowClasses = '';
        this.rowClasses = '';
        this.pageSizeClasses = '';
        this.pageSizeSelectClasses = '';
    }
}
EzTableConfigService.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.2.0", ngImport: i0, type: EzTableConfigService, deps: [], target: i0.ɵɵFactoryTarget.Injectable });
EzTableConfigService.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "14.2.0", ngImport: i0, type: EzTableConfigService, providedIn: 'root' });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.2.0", ngImport: i0, type: EzTableConfigService, decorators: [{
            type: Injectable,
            args: [{
                    providedIn: 'root',
                }]
        }] });

class IterablePipe {
    // This pipe can be used when you want to repeat something in a template n times
    // Saves having to create an array just for template binding
    // *ngFor="let row of numberOfRows | iterable"
    transform(value) {
        const iterable = {};
        iterable[Symbol.iterator] = function* () {
            let n = 0;
            while (n < value) {
                yield ++n;
            }
        };
        return iterable;
    }
}
IterablePipe.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.2.0", ngImport: i0, type: IterablePipe, deps: [], target: i0.ɵɵFactoryTarget.Pipe });
IterablePipe.ɵpipe = i0.ɵɵngDeclarePipe({ minVersion: "14.0.0", version: "14.2.0", ngImport: i0, type: IterablePipe, name: "iterable" });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.2.0", ngImport: i0, type: IterablePipe, decorators: [{
            type: Pipe,
            args: [{
                    name: 'iterable',
                }]
        }] });

class EzTableComponent {
    constructor(config) {
        this.config = config;
        this.data = [];
        this.sortable = true;
        this.loading = false;
        this.loadingRows = 5;
        this.pageSizes = [5, 10, 25, 50, 'All'];
        this.pageSize = 'All';
        this.maxPages = 10;
        this.noDataMessage = this.config.messages.noData;
        this.propertySorting = {
            columnId: null,
            direction: SortDirection.ascending,
            changed: false,
        };
        this.search = '';
        this.breakGrouping = true;
        this.rowClick = new EventEmitter();
        this.cellClick = new EventEmitter();
        this.stateChange = new EventEmitter();
        this.pageData = [];
        this.columnSort = [];
        this.pageNum = 1;
        this.pageNums = [];
        this.filteredPageNums = [];
        this.totalPages = 0;
        this.totalRecords = 0;
        this.start = 0;
        this.finish = 0;
        this.initialised = false;
        this.resolveProperty = resolveProperty;
    }
    set groupBySet(value) {
        if (typeof value === 'string') {
            this.groupBy = { keys: value.split(' ') };
        }
        else {
            this.groupBy = value;
        }
    }
    set pageSizeSet(value) {
        if (value === this.pageSizes[this.pageSizes.length - 1]) {
            this.pageSize = value;
        }
        else {
            this.pageSize = typeof value === 'string' ? parseInt(value) : value;
        }
    }
    set sortId(id) {
        if (this.propertySorting.columnId !== id) {
            this.propertySorting.changed = true;
        }
        this.propertySorting.columnId = id;
    }
    set sortDirection(direction) {
        if (this.propertySorting.direction !== direction) {
            this.propertySorting.changed = true;
        }
        this.propertySorting.direction = direction;
    }
    update() {
        if (!this.data) {
            this.pageData = [];
            this.totalRecords = 0;
            this.totalPages = 1;
            return;
        }
        const searchArray = this.search ? this.search.split(' ') : null;
        let filteredData = searchArray && searchArray.length
            ? this.data.filter((item) => searchArray.every((search) => {
                const searchRegEx = new RegExp(search.replace(/[-[\]{}()*+?.,\\^$|#\s]/g, '\\$&'), 'i');
                return this.columns.some((c) => searchRegEx.test((c.display ? c.display(item) : resolveProperty(item, c.property)) || ''));
            }))
            : [...this.data];
        if (this.columnSort.length > 0) {
            filteredData.sort(multipleSortFunction(...this.columnSort.map((c) => ({
                property: c.property,
                display: c.display,
                direction: c.direction,
                compare: c.compare,
            }))));
        }
        this.totalRecords = filteredData.length;
        if (typeof this.pageSize !== 'string' && this.pageSize < filteredData.length) {
            this.start = this.pageSize * (this.pageNum - 1) + 1;
            this.finish = this.start + this.pageSize - 1;
            if (this.finish > filteredData.length) {
                this.finish = filteredData.length;
            }
            this.totalPages =
                Math.floor(filteredData.length / this.pageSize) + (filteredData.length % this.pageSize === 0 ? 0 : 1);
            filteredData = filteredData.filter((_, i) => i >= this.start - 1 && i < this.finish);
            this.pageNums = pageNums(this.pageNum, this.totalPages, this.maxPages);
        }
        else {
            this.pageNum = 1;
            this.totalPages = 1;
            this.start = 1;
            this.finish = filteredData.length;
        }
        if (this.groupBy &&
            (!this.breakGrouping ||
                this.columnSort.every((column) => { var _a; return !column.breakGrouping || ((_a = this.groupBy) === null || _a === void 0 ? void 0 : _a.keys.some((key) => key === column.property)); }))) {
            filteredData = flattenGroups(groupBy(filteredData, this.groupBy));
        }
        this.pageData = filteredData;
    }
    goto(pageNum) {
        this.pageNum = pageNum;
        this.update();
    }
    next() {
        if (this.pageNum < this.totalPages) {
            this.pageNum++;
            this.update();
        }
    }
    last() {
        if (this.pageNum < this.totalPages) {
            this.pageNum = this.totalPages;
            this.update();
        }
    }
    previous() {
        if (this.pageNum > 1) {
            this.pageNum--;
            this.update();
        }
    }
    first() {
        if (this.pageNum !== 1) {
            this.pageNum = 1;
            this.update();
        }
    }
    headerClick(column, event) {
        event.target.focus();
        this.sort(column, event.shiftKey);
    }
    sort(column, multi) {
        if (this.sortable && column.sortable) {
            const current = this.columnSort.find((c) => c === column);
            if (current) {
                column.direction =
                    column.direction === SortDirection.ascending ? SortDirection.descending : SortDirection.ascending;
            }
            else {
                column.direction = SortDirection.ascending;
            }
            if (!multi) {
                this.columnSort.forEach((c) => {
                    if (c !== column && c.direction) {
                        delete c.direction;
                    }
                });
                this.columnSort = [column];
            }
            else if (!current) {
                this.columnSort.push(column);
            }
            this.update();
        }
    }
    propertySort() {
        const id = this.propertySorting.columnId;
        const column = id ? this.columns.find((c) => c.id === id) : undefined;
        this.columnSort.forEach((c) => {
            if (c !== column && c.direction) {
                delete c.direction;
            }
        });
        if (column) {
            column.direction = this.propertySorting.direction;
            this.columnSort = [column];
        }
        else {
            this.columnSort = [];
        }
        this.propertySorting.changed = false;
    }
    ngOnChanges(_) {
        if (this.initialised) {
            if (this.propertySorting.changed) {
                this.propertySort();
                this.update();
            }
            else {
                this.goto(1);
            }
        }
        else if (!this.tableId) {
            this.tableId = `table_${randomString(32)}`;
        }
    }
    ngAfterContentInit() {
        if (this.state) {
            this.pageSize = this.state.pageSize;
            this.pageNum = this.state.pageNum;
            this.columnSort = Object.keys(this.state.columnSort).reduce((columnSort, id) => {
                var _a;
                const column = this.columns.find((c) => c.id === id);
                if (column) {
                    column.direction = (_a = this.state) === null || _a === void 0 ? void 0 : _a.columnSort[id];
                    columnSort.push(column);
                }
                return columnSort;
            }, []);
        }
        else if (this.propertySorting.changed) {
            this.propertySort();
        }
        this.update();
        this.initialised = true;
    }
    ngOnDestroy() {
        this.stateChange.emit({
            pageNum: this.pageNum,
            pageSize: this.pageSize,
            columnSort: this.columnSort.reduce((columnSort, column) => {
                if (column.id) {
                    columnSort[column.id] = column.direction;
                }
                return columnSort;
            }, {}),
        });
    }
}
EzTableComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.2.0", ngImport: i0, type: EzTableComponent, deps: [{ token: EzTableConfigService }], target: i0.ɵɵFactoryTarget.Component });
EzTableComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "14.2.0", type: EzTableComponent, selector: "ez-table", inputs: { data: "data", tableId: "tableId", sortable: "sortable", loading: "loading", loadingRows: "loadingRows", groupBySet: ["groupBy", "groupBySet"], pageSizes: "pageSizes", pageSizeSet: ["pageSize", "pageSizeSet"], maxPages: "maxPages", noDataMessage: "noDataMessage", sortId: "sortId", sortDirection: "sortDirection", search: "search", state: "state", breakGrouping: "breakGrouping" }, outputs: { rowClick: "rowClick", cellClick: "cellClick", stateChange: "stateChange" }, queries: [{ propertyName: "headings", predicate: EzHeadingComponent }, { propertyName: "columns", predicate: EzColumnComponent }, { propertyName: "footers", predicate: EzFooterComponent }], usesOnChanges: true, ngImport: i0, template: "<div class=\"ez-table\">\r\n  <ng-content></ng-content>\r\n  <table [id]=\"tableId\" [ngClass]=\"config.tableClasses\">\r\n    <thead>\r\n      <tr *ngIf=\"headings?.length\">\r\n        <th *ngFor=\"let heading of headings\" [attr.colspan]=\"heading.columns\" [ngClass]=\"heading.class\">\r\n          {{ heading.title }}\r\n        </th>\r\n      </tr>\r\n      <tr [ngClass]=\"config.headingRowClasses\">\r\n        <th *ngFor=\"let column of columns\" [ngClass]=\"column.headingClass\" [attr.id]=\"column.headingId\" [attr.width]=\"column.width\" [attr.tabindex]=\"column.sortable ? '0' : null\"\r\n          [attr.aria-controls]=\"column.sortable ? tableId : null\" [attr.aria-sort]=\"column.direction\" [attr.aria-label]=\"column.heading || column.property\" (keydown.enter)=\"sort(column, false)\"\r\n          (keydown.shift.enter)=\"sort(column, true)\" (click)=\"headerClick(column, $event)\">\r\n          <span>{{ column.heading ?? column.property }}</span>\r\n        </th>\r\n      </tr>\r\n    </thead>\r\n    <tbody>\r\n      <ng-container *ngIf=\"loading else dataRows\">\r\n        <tr *ngFor=\"let row of loadingRows | iterable\" class=\"ez-loading-row\">\r\n          <td *ngFor=\"let column of columns\"><span>&nbsp;</span></td>\r\n        </tr>\r\n      </ng-container>\r\n      <ng-template #dataRows>\r\n        <tr *ngIf=\"pageData.length === 0; else pageDataTemplate\">\r\n          <td [colSpan]=\"columns.length\">\r\n            {{ noDataMessage }}\r\n          </td>\r\n        </tr>\r\n        <ng-template #pageDataTemplate>\r\n          <tr *ngFor=\"let item of pageData; index as i\" [ngClass]=\"config.rowClasses\" (click)=\"rowClick.emit(item)\">\r\n            <ng-container *ngFor=\"let column of columns\">\r\n              <td *ngIf=\"!item._rows || item._rows[column.property] !== -1\" [attr.rowspan]=\"item._rows && item._rows[column.property]\" [ngClass]=\"column.cellClass\">\r\n                <ng-container *ngTemplateOutlet=\"column.template || defaultColumTemplate; context: { $implicit: item, index: i }\" (click)=\"cellClick.emit(item)\">\r\n                </ng-container>\r\n                <ng-template #defaultColumTemplate let-item>\r\n                  {{ column.display ? column.display(item) : resolveProperty(item, column.property) }}\r\n                </ng-template>\r\n              </td>\r\n            </ng-container>\r\n          </tr>\r\n        </ng-template>\r\n      </ng-template>\r\n    </tbody>\r\n    <tfoot *ngIf=\"footers?.length\">\r\n      <tr [ngClass]=\"config.footerRowClasses\">\r\n        <td *ngFor=\"let footer of footers\" [attr.colspan]=\"footer.columns\" [ngClass]=\"footer.cellClass\">\r\n          <ng-container *ngTemplateOutlet=\"footer.template || defaultFooterTemplate; context: { data: data, pageData: pageData, search: search }\">\r\n          </ng-container>\r\n          <ng-template #defaultFooterTemplate>\r\n            {{ footer.display ? footer.display(pageData, data) : footer.value }}\r\n          </ng-template>\r\n        </td>\r\n      </tr>\r\n    </tfoot>\r\n  </table>\r\n  <ng-content select=\"[footer]\"></ng-content>\r\n</div>", styles: [""], dependencies: [{ kind: "directive", type: i1$1.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i1$1.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { kind: "directive", type: i1$1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: i1$1.NgTemplateOutlet, selector: "[ngTemplateOutlet]", inputs: ["ngTemplateOutletContext", "ngTemplateOutlet", "ngTemplateOutletInjector"] }, { kind: "pipe", type: IterablePipe, name: "iterable" }] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.2.0", ngImport: i0, type: EzTableComponent, decorators: [{
            type: Component,
            args: [{ selector: 'ez-table', template: "<div class=\"ez-table\">\r\n  <ng-content></ng-content>\r\n  <table [id]=\"tableId\" [ngClass]=\"config.tableClasses\">\r\n    <thead>\r\n      <tr *ngIf=\"headings?.length\">\r\n        <th *ngFor=\"let heading of headings\" [attr.colspan]=\"heading.columns\" [ngClass]=\"heading.class\">\r\n          {{ heading.title }}\r\n        </th>\r\n      </tr>\r\n      <tr [ngClass]=\"config.headingRowClasses\">\r\n        <th *ngFor=\"let column of columns\" [ngClass]=\"column.headingClass\" [attr.id]=\"column.headingId\" [attr.width]=\"column.width\" [attr.tabindex]=\"column.sortable ? '0' : null\"\r\n          [attr.aria-controls]=\"column.sortable ? tableId : null\" [attr.aria-sort]=\"column.direction\" [attr.aria-label]=\"column.heading || column.property\" (keydown.enter)=\"sort(column, false)\"\r\n          (keydown.shift.enter)=\"sort(column, true)\" (click)=\"headerClick(column, $event)\">\r\n          <span>{{ column.heading ?? column.property }}</span>\r\n        </th>\r\n      </tr>\r\n    </thead>\r\n    <tbody>\r\n      <ng-container *ngIf=\"loading else dataRows\">\r\n        <tr *ngFor=\"let row of loadingRows | iterable\" class=\"ez-loading-row\">\r\n          <td *ngFor=\"let column of columns\"><span>&nbsp;</span></td>\r\n        </tr>\r\n      </ng-container>\r\n      <ng-template #dataRows>\r\n        <tr *ngIf=\"pageData.length === 0; else pageDataTemplate\">\r\n          <td [colSpan]=\"columns.length\">\r\n            {{ noDataMessage }}\r\n          </td>\r\n        </tr>\r\n        <ng-template #pageDataTemplate>\r\n          <tr *ngFor=\"let item of pageData; index as i\" [ngClass]=\"config.rowClasses\" (click)=\"rowClick.emit(item)\">\r\n            <ng-container *ngFor=\"let column of columns\">\r\n              <td *ngIf=\"!item._rows || item._rows[column.property] !== -1\" [attr.rowspan]=\"item._rows && item._rows[column.property]\" [ngClass]=\"column.cellClass\">\r\n                <ng-container *ngTemplateOutlet=\"column.template || defaultColumTemplate; context: { $implicit: item, index: i }\" (click)=\"cellClick.emit(item)\">\r\n                </ng-container>\r\n                <ng-template #defaultColumTemplate let-item>\r\n                  {{ column.display ? column.display(item) : resolveProperty(item, column.property) }}\r\n                </ng-template>\r\n              </td>\r\n            </ng-container>\r\n          </tr>\r\n        </ng-template>\r\n      </ng-template>\r\n    </tbody>\r\n    <tfoot *ngIf=\"footers?.length\">\r\n      <tr [ngClass]=\"config.footerRowClasses\">\r\n        <td *ngFor=\"let footer of footers\" [attr.colspan]=\"footer.columns\" [ngClass]=\"footer.cellClass\">\r\n          <ng-container *ngTemplateOutlet=\"footer.template || defaultFooterTemplate; context: { data: data, pageData: pageData, search: search }\">\r\n          </ng-container>\r\n          <ng-template #defaultFooterTemplate>\r\n            {{ footer.display ? footer.display(pageData, data) : footer.value }}\r\n          </ng-template>\r\n        </td>\r\n      </tr>\r\n    </tfoot>\r\n  </table>\r\n  <ng-content select=\"[footer]\"></ng-content>\r\n</div>" }]
        }], ctorParameters: function () { return [{ type: EzTableConfigService }]; }, propDecorators: { data: [{
                type: Input
            }],
        // give it a random Id so it is unique
        tableId: [{
                type: Input
            }], sortable: [{
                type: Input
            }], loading: [{
                type: Input
            }], loadingRows: [{
                type: Input
            }], groupBySet: [{
                type: Input,
                args: ['groupBy']
            }], pageSizes: [{
                type: Input
            }], pageSizeSet: [{
                type: Input,
                args: ['pageSize']
            }], maxPages: [{
                type: Input
            }], noDataMessage: [{
                type: Input
            }], sortId: [{
                type: Input
            }], sortDirection: [{
                type: Input
            }], search: [{
                type: Input,
                args: ['search']
            }], state: [{
                type: Input
            }], breakGrouping: [{
                type: Input
            }], rowClick: [{
                type: Output
            }], cellClick: [{
                type: Output
            }], stateChange: [{
                type: Output
            }], headings: [{
                type: ContentChildren,
                args: [EzHeadingComponent]
            }], columns: [{
                type: ContentChildren,
                args: [EzColumnComponent]
            }], footers: [{
                type: ContentChildren,
                args: [EzFooterComponent]
            }] } });

class EzTablePagerComponent {
    constructor(table) {
        this.table = table;
        this.config = this.table.config;
    }
    changeSize(pageSize) {
        this.table.pageSizeSet = pageSize;
        this.table.goto(1);
    }
}
EzTablePagerComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.2.0", ngImport: i0, type: EzTablePagerComponent, deps: [{ token: EzTableComponent }], target: i0.ɵɵFactoryTarget.Component });
EzTablePagerComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "14.2.0", type: EzTablePagerComponent, selector: "ez-table-pager", ngImport: i0, template: "<div class=\"ez-page-size\" [ngClass]=\"config.pageSizeClasses\">\r\n  <label class=\"\">\r\n    Show\r\n    <select [ngClass]=\"config.pageSizeSelectClasses\" [value]=\"table.pageSize\" (change)=\"changeSize($any($event.target).value)\" [attr.aria-controls]=\"table.tableId\">\r\n      <option [value]=\"size\" *ngFor=\"let size of table.pageSizes\" [selected]=\"size === table.pageSize\">{{size}}</option>\r\n    </select>\r\n    records - Showing\r\n    <ng-container *ngIf=\"table.pageData.length === 0\">0</ng-container>\r\n    <ng-container *ngIf=\"table.pageData.length > 0\">{{table.start}}</ng-container>\r\n    <ng-container *ngIf=\"table.pageData.length > 1\">to {{table.finish}}</ng-container>\r\n    of {{table.totalRecords}} records\r\n    <ng-container *ngIf=\"table.data && table.totalRecords !== table.data.length\">(filtered from {{table.data.length}} total records)</ng-container>\r\n  </label>\r\n</div>\r\n<nav class=\"ez-page-select\" *ngIf=\"table.totalPages > 1\">\r\n  <ul class=\"pagination\">\r\n    <li class=\"page-item\" [ngClass]=\"{ 'disabled': table.pageNum === 1 }\">\r\n      <a href=\"javascript:void(0)\" class=\"page-link\" [attr.aria-controls]=\"table.tableId\" [attr.data-dt-idx]=\"1\" [tabindex]=\"table.pageNum === 1 ? -1 : 0\"\r\n        (keydown.enter)=\"table.first()\" (click)=\"table.first()\">First</a>\r\n    </li>\r\n\r\n    <li class=\"page-item\" [ngClass]=\"{ 'disabled': table.pageNum === 1 }\">\r\n      <a href=\"javascript:void(0)\" class=\"page-link\" [attr.aria-controls]=\"table.tableId\" [attr.data-dt-idx]=\"table.pageNum === 1 ? 1 : table.pageNum - 1\"\r\n        [tabindex]=\"table.pageNum === 1 ? -1 : 0\" (keydown.enter)=\"table.previous()\" (click)=\"table.previous()\">Previous</a>\r\n    </li>\r\n\r\n    <li *ngFor=\"let pn of table.pageNums\" class=\"page-item\" [ngClass]=\"{ 'active': table.pageNum === pn }\">\r\n      <a href=\"javascript:void(0)\" class=\"page-link\" [tabIndex]=\"table.pageNum === pn ? -1 : 0\" [attr.aria-controls]=\"table.tableId\" [attr.data-dt-idx]=\"pn\"\r\n        (keydown.enter)=\"table.goto(pn)\" (click)=\"table.goto(pn)\">{{pn}}</a>\r\n    </li>\r\n\r\n    <li class=\"page-item\" [ngClass]=\"{ 'disabled': table.pageNum === table.totalPages }\">\r\n      <a href=\"javascript:void(0)\" class=\"page-link\" [attr.aria-controls]=\"table.tableId\"\r\n        [attr.data-dt-idx]=\"table.pageNum === table.totalPages ? table.totalPages : table.pageNum + 1\" [tabindex]=\"table.pageNum === table.totalPages ? -1 : 0\"\r\n        (keydown.enter)=\"table.next()\" (click)=\"table.next()\">Next</a>\r\n    </li>\r\n\r\n    <li class=\"page-item\" [ngClass]=\"{ 'disabled': table.pageNum === table.totalPages }\">\r\n      <a href=\"javascript:void(0)\" class=\"page-link\" [attr.aria-controls]=\"table.tableId\" [attr.data-dt-idx]=\"table.totalPages\"\r\n        [tabindex]=\"table.pageNum === table.totalPages ? -1 : 0\" (keydown.enter)=\"table.last()\" (click)=\"table.last()\">Last</a>\r\n    </li>\r\n  </ul>\r\n</nav>", styles: [""], dependencies: [{ kind: "directive", type: i1$1.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i1$1.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { kind: "directive", type: i1$1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.2.0", ngImport: i0, type: EzTablePagerComponent, decorators: [{
            type: Component,
            args: [{ selector: 'ez-table-pager', template: "<div class=\"ez-page-size\" [ngClass]=\"config.pageSizeClasses\">\r\n  <label class=\"\">\r\n    Show\r\n    <select [ngClass]=\"config.pageSizeSelectClasses\" [value]=\"table.pageSize\" (change)=\"changeSize($any($event.target).value)\" [attr.aria-controls]=\"table.tableId\">\r\n      <option [value]=\"size\" *ngFor=\"let size of table.pageSizes\" [selected]=\"size === table.pageSize\">{{size}}</option>\r\n    </select>\r\n    records - Showing\r\n    <ng-container *ngIf=\"table.pageData.length === 0\">0</ng-container>\r\n    <ng-container *ngIf=\"table.pageData.length > 0\">{{table.start}}</ng-container>\r\n    <ng-container *ngIf=\"table.pageData.length > 1\">to {{table.finish}}</ng-container>\r\n    of {{table.totalRecords}} records\r\n    <ng-container *ngIf=\"table.data && table.totalRecords !== table.data.length\">(filtered from {{table.data.length}} total records)</ng-container>\r\n  </label>\r\n</div>\r\n<nav class=\"ez-page-select\" *ngIf=\"table.totalPages > 1\">\r\n  <ul class=\"pagination\">\r\n    <li class=\"page-item\" [ngClass]=\"{ 'disabled': table.pageNum === 1 }\">\r\n      <a href=\"javascript:void(0)\" class=\"page-link\" [attr.aria-controls]=\"table.tableId\" [attr.data-dt-idx]=\"1\" [tabindex]=\"table.pageNum === 1 ? -1 : 0\"\r\n        (keydown.enter)=\"table.first()\" (click)=\"table.first()\">First</a>\r\n    </li>\r\n\r\n    <li class=\"page-item\" [ngClass]=\"{ 'disabled': table.pageNum === 1 }\">\r\n      <a href=\"javascript:void(0)\" class=\"page-link\" [attr.aria-controls]=\"table.tableId\" [attr.data-dt-idx]=\"table.pageNum === 1 ? 1 : table.pageNum - 1\"\r\n        [tabindex]=\"table.pageNum === 1 ? -1 : 0\" (keydown.enter)=\"table.previous()\" (click)=\"table.previous()\">Previous</a>\r\n    </li>\r\n\r\n    <li *ngFor=\"let pn of table.pageNums\" class=\"page-item\" [ngClass]=\"{ 'active': table.pageNum === pn }\">\r\n      <a href=\"javascript:void(0)\" class=\"page-link\" [tabIndex]=\"table.pageNum === pn ? -1 : 0\" [attr.aria-controls]=\"table.tableId\" [attr.data-dt-idx]=\"pn\"\r\n        (keydown.enter)=\"table.goto(pn)\" (click)=\"table.goto(pn)\">{{pn}}</a>\r\n    </li>\r\n\r\n    <li class=\"page-item\" [ngClass]=\"{ 'disabled': table.pageNum === table.totalPages }\">\r\n      <a href=\"javascript:void(0)\" class=\"page-link\" [attr.aria-controls]=\"table.tableId\"\r\n        [attr.data-dt-idx]=\"table.pageNum === table.totalPages ? table.totalPages : table.pageNum + 1\" [tabindex]=\"table.pageNum === table.totalPages ? -1 : 0\"\r\n        (keydown.enter)=\"table.next()\" (click)=\"table.next()\">Next</a>\r\n    </li>\r\n\r\n    <li class=\"page-item\" [ngClass]=\"{ 'disabled': table.pageNum === table.totalPages }\">\r\n      <a href=\"javascript:void(0)\" class=\"page-link\" [attr.aria-controls]=\"table.tableId\" [attr.data-dt-idx]=\"table.totalPages\"\r\n        [tabindex]=\"table.pageNum === table.totalPages ? -1 : 0\" (keydown.enter)=\"table.last()\" (click)=\"table.last()\">Last</a>\r\n    </li>\r\n  </ul>\r\n</nav>" }]
        }], ctorParameters: function () { return [{ type: EzTableComponent }]; } });

class EzTableSearchComponent {
    constructor(table) {
        this.table = table;
        this.label = 'Search';
        this.searchStr = '';
    }
    search(search) {
        this.searchStr = search;
        this.table.search = search;
        this.table.goto(1);
    }
}
EzTableSearchComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.2.0", ngImport: i0, type: EzTableSearchComponent, deps: [{ token: EzTableComponent }], target: i0.ɵɵFactoryTarget.Component });
EzTableSearchComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "14.2.0", type: EzTableSearchComponent, selector: "ez-table-search", inputs: { label: "label" }, ngImport: i0, template: "<label class=\"ez-table-search\">\r\n  {{ label }}\r\n  <input type=\"search\" [value]=\"searchStr\" (keyup)=\"search($any($event.target).value)\" [attr.aria-controls]=\"table.tableId\" />\r\n</label>", styles: ["input::-webkit-search-cancel-button{display:none}\n"] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.2.0", ngImport: i0, type: EzTableSearchComponent, decorators: [{
            type: Component,
            args: [{ selector: 'ez-table-search', template: "<label class=\"ez-table-search\">\r\n  {{ label }}\r\n  <input type=\"search\" [value]=\"searchStr\" (keyup)=\"search($any($event.target).value)\" [attr.aria-controls]=\"table.tableId\" />\r\n</label>", styles: ["input::-webkit-search-cancel-button{display:none}\n"] }]
        }], ctorParameters: function () { return [{ type: EzTableComponent }]; }, propDecorators: { label: [{
                type: Input
            }] } });

class IterablePipeModule {
}
IterablePipeModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.2.0", ngImport: i0, type: IterablePipeModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
IterablePipeModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "14.2.0", ngImport: i0, type: IterablePipeModule, declarations: [IterablePipe], imports: [CommonModule], exports: [IterablePipe] });
IterablePipeModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "14.2.0", ngImport: i0, type: IterablePipeModule, imports: [CommonModule] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.2.0", ngImport: i0, type: IterablePipeModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [IterablePipe],
                    exports: [IterablePipe],
                    imports: [CommonModule],
                }]
        }] });

class EzTableModule {
}
EzTableModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.2.0", ngImport: i0, type: EzTableModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
EzTableModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "14.2.0", ngImport: i0, type: EzTableModule, declarations: [EzColumnComponent,
        EzFooterComponent,
        EzHeadingComponent,
        EzTableComponent,
        EzTablePagerComponent,
        EzTableSearchComponent], imports: [CommonModule, IterablePipeModule], exports: [EzColumnComponent,
        EzFooterComponent,
        EzHeadingComponent,
        EzTableComponent,
        EzTablePagerComponent,
        EzTableSearchComponent] });
EzTableModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "14.2.0", ngImport: i0, type: EzTableModule, imports: [CommonModule, IterablePipeModule] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.2.0", ngImport: i0, type: EzTableModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [
                        EzColumnComponent,
                        EzFooterComponent,
                        EzHeadingComponent,
                        EzTableComponent,
                        EzTablePagerComponent,
                        EzTableSearchComponent,
                    ],
                    imports: [CommonModule, IterablePipeModule],
                    exports: [
                        EzColumnComponent,
                        EzFooterComponent,
                        EzHeadingComponent,
                        EzTableComponent,
                        EzTablePagerComponent,
                        EzTableSearchComponent,
                    ],
                }]
        }] });

class EzTableBootstrapConfigService extends EzTableConfigService {
    constructor() {
        super();
        this.tableClasses = 'table';
        this.pageSizeClasses = 'form-group form-inline';
        this.pageSizeClasses = 'form-control form-control-sm m-1';
    }
}
EzTableBootstrapConfigService.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.2.0", ngImport: i0, type: EzTableBootstrapConfigService, deps: [], target: i0.ɵɵFactoryTarget.Injectable });
EzTableBootstrapConfigService.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "14.2.0", ngImport: i0, type: EzTableBootstrapConfigService, providedIn: 'root' });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.2.0", ngImport: i0, type: EzTableBootstrapConfigService, decorators: [{
            type: Injectable,
            args: [{
                    providedIn: 'root',
                }]
        }], ctorParameters: function () { return []; } });

class EzTabComponent {
    constructor() {
        this.disabled = false;
        this.tabSelected = new EventEmitter();
    }
    ngOnInit() {
        if (!this.name) {
            this.name = randomString(16);
        }
    }
}
EzTabComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.2.0", ngImport: i0, type: EzTabComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
EzTabComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "14.2.0", type: EzTabComponent, selector: "ez-tab", inputs: { heading: "heading", name: "name", route: "route", disabled: "disabled" }, outputs: { tabSelected: "tabSelected" }, viewQueries: [{ propertyName: "template", first: true, predicate: TemplateRef, descendants: true }], ngImport: i0, template: "<ng-template>\r\n  <ng-content></ng-content>\r\n</ng-template>", styles: [""] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.2.0", ngImport: i0, type: EzTabComponent, decorators: [{
            type: Component,
            args: [{ selector: 'ez-tab', template: "<ng-template>\r\n  <ng-content></ng-content>\r\n</ng-template>" }]
        }], propDecorators: { heading: [{
                type: Input
            }], name: [{
                type: Input
            }], route: [{
                type: Input
            }], disabled: [{
                type: Input
            }], tabSelected: [{
                type: Output
            }], template: [{
                type: ViewChild,
                args: [TemplateRef]
            }] } });

class EzTabsComponent {
    constructor(router, route) {
        this.router = router;
        this.route = route;
        this.currentChange = new EventEmitter();
        this.routeChange = (tab, active) => {
            if (!active && this.selectedTab === tab) {
                this.selectedTab = undefined;
            }
            else if (active) {
                this.selectTab(tab);
            }
        };
    }
    set currentSet(name) {
        var _a;
        const tab = (_a = this.tabs) === null || _a === void 0 ? void 0 : _a.find((tab) => tab.name === name);
        if (tab) {
            this.selectTab(tab);
        }
        else {
            this.current = name;
        }
    }
    selectTab(tab) {
        var _a;
        if (!tab.disabled && this.selectedTab !== tab) {
            if (!tab.route && ((_a = this.selectedTab) === null || _a === void 0 ? void 0 : _a.route)) {
                this.router.navigate(['.'], { relativeTo: this.route });
            }
            this.selectedTab = tab;
            if (this.current !== tab.name) {
                this.current = tab.name;
                this.currentChange.emit(tab.name);
            }
            tab.tabSelected.emit();
        }
    }
    ngAfterContentInit() {
        setTimeout(() => {
            if (this.current && !this.selectedTab) {
                this.currentSet = this.current;
            }
        });
    }
}
EzTabsComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.2.0", ngImport: i0, type: EzTabsComponent, deps: [{ token: i1$2.Router }, { token: i1$2.ActivatedRoute }], target: i0.ɵɵFactoryTarget.Component });
EzTabsComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "14.2.0", type: EzTabsComponent, selector: "ez-tabs", inputs: { currentSet: ["current", "currentSet"] }, outputs: { currentChange: "currentChange" }, queries: [{ propertyName: "tabs", predicate: EzTabComponent }], ngImport: i0, template: "<div class=\"ez-tab-container\">\r\n  <ng-content select=\"[left]\"></ng-content>\r\n  <ul role=\"tablist\">\r\n    <li *ngFor=\"let tab of tabs\" role=\"presentation\" [ngClass]=\"{ active: tab === selectedTab }\">\r\n      <a *ngIf=\"tab.route; else noRoute\" role=\"tab\" [attr.aria-selected]=\"tab === selectedTab\" [attr.aria-controls]=\"'tabpanel-' + tab.name\" [routerLink]=\"tab.route\"\r\n        routerLinkActive (isActiveChange)=\"routeChange(tab, $event)\">\r\n        {{ tab.heading }}\r\n      </a>\r\n      <ng-template #noRoute>\r\n        <a href=\"javacript:void(0)\" role=\"tab\" [attr.aria-selected]=\"tab === selectedTab\" [attr.aria-controls]=\"'tabpanel-' + tab.name\" (click)=\"selectTab(tab)\">\r\n          {{ tab.heading }}\r\n        </a>\r\n      </ng-template>\r\n    </li>\r\n  </ul>\r\n  <ng-content select=\"[right]\"></ng-content>\r\n</div>\r\n\r\n<div [attr.role]=\"selectedTab && 'tabpanel'\" [attr.id]=\"selectedTab && 'tabpanel-' + selectedTab.name\">\r\n  <ng-content></ng-content>\r\n  <ng-container *ngIf=\"selectedTab?.template\">\r\n    <ng-container *ngTemplateOutlet=\"selectedTab?.template ?? null\"></ng-container>\r\n  </ng-container>\r\n  <ng-content select=\"[footer]\"></ng-content>\r\n</div>", styles: [""], dependencies: [{ kind: "directive", type: i1$1.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i1$1.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { kind: "directive", type: i1$1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: i1$1.NgTemplateOutlet, selector: "[ngTemplateOutlet]", inputs: ["ngTemplateOutletContext", "ngTemplateOutlet", "ngTemplateOutletInjector"] }, { kind: "directive", type: i1$2.RouterLinkWithHref, selector: "a[routerLink],area[routerLink]", inputs: ["target", "queryParams", "fragment", "queryParamsHandling", "state", "relativeTo", "preserveFragment", "skipLocationChange", "replaceUrl", "routerLink"] }, { kind: "directive", type: i1$2.RouterLinkActive, selector: "[routerLinkActive]", inputs: ["routerLinkActiveOptions", "ariaCurrentWhenActive", "routerLinkActive"], outputs: ["isActiveChange"], exportAs: ["routerLinkActive"] }] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.2.0", ngImport: i0, type: EzTabsComponent, decorators: [{
            type: Component,
            args: [{ selector: 'ez-tabs', template: "<div class=\"ez-tab-container\">\r\n  <ng-content select=\"[left]\"></ng-content>\r\n  <ul role=\"tablist\">\r\n    <li *ngFor=\"let tab of tabs\" role=\"presentation\" [ngClass]=\"{ active: tab === selectedTab }\">\r\n      <a *ngIf=\"tab.route; else noRoute\" role=\"tab\" [attr.aria-selected]=\"tab === selectedTab\" [attr.aria-controls]=\"'tabpanel-' + tab.name\" [routerLink]=\"tab.route\"\r\n        routerLinkActive (isActiveChange)=\"routeChange(tab, $event)\">\r\n        {{ tab.heading }}\r\n      </a>\r\n      <ng-template #noRoute>\r\n        <a href=\"javacript:void(0)\" role=\"tab\" [attr.aria-selected]=\"tab === selectedTab\" [attr.aria-controls]=\"'tabpanel-' + tab.name\" (click)=\"selectTab(tab)\">\r\n          {{ tab.heading }}\r\n        </a>\r\n      </ng-template>\r\n    </li>\r\n  </ul>\r\n  <ng-content select=\"[right]\"></ng-content>\r\n</div>\r\n\r\n<div [attr.role]=\"selectedTab && 'tabpanel'\" [attr.id]=\"selectedTab && 'tabpanel-' + selectedTab.name\">\r\n  <ng-content></ng-content>\r\n  <ng-container *ngIf=\"selectedTab?.template\">\r\n    <ng-container *ngTemplateOutlet=\"selectedTab?.template ?? null\"></ng-container>\r\n  </ng-container>\r\n  <ng-content select=\"[footer]\"></ng-content>\r\n</div>" }]
        }], ctorParameters: function () { return [{ type: i1$2.Router }, { type: i1$2.ActivatedRoute }]; }, propDecorators: { currentSet: [{
                type: Input,
                args: ['current']
            }], currentChange: [{
                type: Output
            }], tabs: [{
                type: ContentChildren,
                args: [EzTabComponent]
            }] } });

class EzTabsModule {
}
EzTabsModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.2.0", ngImport: i0, type: EzTabsModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
EzTabsModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "14.2.0", ngImport: i0, type: EzTabsModule, declarations: [EzTabComponent, EzTabsComponent], imports: [CommonModule, RouterModule], exports: [EzTabComponent, EzTabsComponent] });
EzTabsModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "14.2.0", ngImport: i0, type: EzTabsModule, imports: [CommonModule, RouterModule] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.2.0", ngImport: i0, type: EzTabsModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [EzTabComponent, EzTabsComponent],
                    exports: [EzTabComponent, EzTabsComponent],
                    imports: [CommonModule, RouterModule],
                }]
        }] });

class ClonePipe {
    transform(value) {
        return clone(value);
    }
}
ClonePipe.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.2.0", ngImport: i0, type: ClonePipe, deps: [], target: i0.ɵɵFactoryTarget.Pipe });
ClonePipe.ɵpipe = i0.ɵɵngDeclarePipe({ minVersion: "14.0.0", version: "14.2.0", ngImport: i0, type: ClonePipe, name: "clone" });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.2.0", ngImport: i0, type: ClonePipe, decorators: [{
            type: Pipe,
            args: [{
                    name: 'clone',
                }]
        }] });

class ClonePipeModule {
}
ClonePipeModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.2.0", ngImport: i0, type: ClonePipeModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
ClonePipeModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "14.2.0", ngImport: i0, type: ClonePipeModule, declarations: [ClonePipe], imports: [CommonModule], exports: [ClonePipe] });
ClonePipeModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "14.2.0", ngImport: i0, type: ClonePipeModule, imports: [CommonModule] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.2.0", ngImport: i0, type: ClonePipeModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [ClonePipe],
                    exports: [ClonePipe],
                    imports: [CommonModule],
                }]
        }] });

/*
 * Public API Surface of ngx-ez
 */

/**
 * Generated bundle index. Do not edit.
 */

export { AllowedDirective, AllowedValidatorModule, AlphaStartDirective, AphaSTartValidatorModule, CheckboxesRequiredDirective, CheckboxesRequiredValidatorModule, ClonePipe, ClonePipeModule, EzCheckboxComponent, EzCheckboxModule, EzCheckboxesComponent, EzCheckboxesModule, EzColumnComponent, EzControlBaseComponent, EzControlComponent, EzFooterComponent, EzFormConfigDirective, EzFormConfigService, EzFormDirective, EzFormReadonlyDirective, EzFormsModule, EzHeadingComponent, EzModalComponent, EzModalModule, EzPasswordComponent, EzPasswordModule, EzRadioComponent, EzRadioModule, EzSelectComponent, EzSelectModule, EzTabComponent, EzTableBootstrapConfigService, EzTableComponent, EzTableConfigService, EzTableModule, EzTablePagerComponent, EzTableSearchComponent, EzTabsComponent, EzTabsModule, EzTextComponent, EzTextModule, EzYesNoComponent, EzYesNoModule, IterablePipe, IterablePipeModule, RangeDirective, RangeValidatorModule, ReferencePipe, ReferencePipeModule, SameDirective, SameValidatorModule, ValidDirective, ValidatorBaseDirective };
//# sourceMappingURL=ngx-ez.mjs.map
