import { ControlValueAccessor } from '@angular/forms';
import { EzControlProperties } from '../models/ez-controls-properties';
import { EzFormConfig } from '../models/ez-form-config';
import * as i0 from "@angular/core";
export declare class EzControlBaseComponent<T> implements ControlValueAccessor {
    properties: EzControlProperties;
    config: EzFormConfig;
    metaData: {
        localReadonly: boolean;
        directiveReadonly: boolean;
    };
    set fieldset(value: boolean | string);
    set labelledby(value: string);
    set maxlength(value: string | number);
    set name(value: string);
    set placeholder(value: string);
    set readonly(value: boolean | string);
    set required(value: boolean | string);
    messages: {
        [key: string]: string;
    };
    value?: T;
    writeValue(value: T): void;
    propagateChange: (value: T) => void;
    registerOnChange(fn: (value: T) => void): void;
    registerOnTouched(): void;
    onChange(value: T): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<EzControlBaseComponent<any>, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<EzControlBaseComponent<any>, "ez-control-base", never, { "fieldset": "fieldset"; "labelledby": "labelledby"; "maxlength": "maxlength"; "name": "name"; "placeholder": "placeholder"; "readonly": "readonly"; "required": "required"; "messages": "messages"; }, {}, never, never, false>;
}
