import { QueryList, AfterContentInit, OnDestroy, EventEmitter, SimpleChanges, OnChanges } from '@angular/core';
import { EzColumnComponent } from '../ez-column/ez-column.component';
import { EzFooterComponent } from '../ez-footer/ez-footer.component';
import { EzTableState } from '../../models/ez-table-state';
import { EzTableConfigService } from '../../services/ez-table-config.service';
import { EzHeadingComponent } from '../ez-heading/ez-heading.component';
import { GroupBy } from 'ez-functions';
import { SortDirection } from 'ez-functions';
import * as i0 from "@angular/core";
export declare class EzTableComponent implements AfterContentInit, OnDestroy, OnChanges {
    config: EzTableConfigService;
    data: any[];
    tableId: string;
    sortable: boolean;
    loading: boolean;
    loadingRows: number;
    set groupBySet(value: string | GroupBy);
    groupBy?: GroupBy;
    pageSizes: any[];
    pageSize: string | number;
    set pageSizeSet(value: string | number);
    maxPages: number;
    noDataMessage: string;
    private propertySorting;
    set sortId(id: string | null | undefined);
    set sortDirection(direction: SortDirection);
    search: string;
    state?: EzTableState;
    breakGrouping: boolean;
    rowClick: EventEmitter<any>;
    cellClick: EventEmitter<any>;
    stateChange: EventEmitter<EzTableState>;
    pageData: any[];
    columnSort: EzColumnComponent[];
    pageNum: number;
    pageNums: number[];
    filteredPageNums: never[];
    totalPages: number;
    totalRecords: number;
    start: number;
    finish: number;
    initialised: boolean;
    headings: QueryList<EzHeadingComponent>;
    columns: QueryList<EzColumnComponent>;
    footers: QueryList<EzFooterComponent>;
    resolveProperty: (obj: any, property?: string | undefined) => any;
    constructor(config: EzTableConfigService);
    update(): void;
    goto(pageNum: number): void;
    next(): void;
    last(): void;
    previous(): void;
    first(): void;
    headerClick(column: EzColumnComponent, event: MouseEvent): void;
    sort(column: EzColumnComponent, multi: boolean): void;
    private propertySort;
    ngOnChanges(_: SimpleChanges): void;
    ngAfterContentInit(): void;
    ngOnDestroy(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<EzTableComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<EzTableComponent, "ez-table", never, { "data": "data"; "tableId": "tableId"; "sortable": "sortable"; "loading": "loading"; "loadingRows": "loadingRows"; "groupBySet": "groupBy"; "pageSizes": "pageSizes"; "pageSizeSet": "pageSize"; "maxPages": "maxPages"; "noDataMessage": "noDataMessage"; "sortId": "sortId"; "sortDirection": "sortDirection"; "search": "search"; "state": "state"; "breakGrouping": "breakGrouping"; }, { "rowClick": "rowClick"; "cellClick": "cellClick"; "stateChange": "stateChange"; }, ["headings", "columns", "footers"], ["*", "[footer]"], false>;
}
